using System;
using WebCab.Libraries.Statistics.PDistributions;

public class BinomialProbabilitydsiDistributionClient {
	public static void Main () {
		try {
			BinomialProbabilityDistribution proxy = new BinomialProbabilityDistribution ();
			
			Console.WriteLine ("SetProbabilityOfASuccess (0.5)");
			proxy.SetProbabilityOfASuccess(0.5);
			Console.WriteLine ("SetNumberOfTrials (10)");
			proxy.SetNumberOfTrials(10);
			
			Console.WriteLine ("GetMean (): " + proxy.GetMean ());
			Console.WriteLine ("GetVariance (): " + proxy.GetVariance ());
			Console.WriteLine ("GetProbabilityOfASuccess (): " + proxy.GetProbabilityOfASuccess ());
			Console.WriteLine ("GetNumberOfTrials (): " + proxy.GetNumberOfTrials ());
			Console.WriteLine ("GetProbabilityOfASuccess (): " + proxy.GetProbabilityOfASuccess ());
			Console.WriteLine ("GetProbability (1, 1): " + proxy.Probability (1, 1));
			Console.WriteLine ("ProbabilityUp (1): " + proxy.ProbabilityUp (1));
			Console.WriteLine ("Inverse(0.95): " + proxy.Inverse(0.95));
			Console.WriteLine ("GetRandomNumber():" + proxy.GetRandomNumber());

			// Here we evaluate the probability and cumulative probability for each of the
			// possible number of successes. 
		     for (int i=0;i< proxy.GetNumberOfTrials();i++)
               {
               Console.WriteLine ("Probability(" + i + "):" + proxy.Probability(i));
               Console.WriteLine ("CumulativeProbability(" + i + "):" + proxy.CumulativeProbability(i));
               }

               // Create an array to record the number of times a given number of successes will
			// be returned by Binomial Probability distributions Random number generator.
               int[] numberOfTimes = new int[proxy.GetNumberOfTrials()+1];

               for (int u =0; u<=proxy.GetNumberOfTrials(); u++)
               {
                    numberOfTimes[u] = 0;
               }

               for (int j =1; j<800; j++)
               {
                    int k;
                    k = proxy.GetRandomNumber();
                    numberOfTimes[k] = numberOfTimes[k] +1;
               }

               for (int h=0; h <= proxy.GetNumberOfTrials(); h++)
               {
                    Console.WriteLine("Number of " + h + "'s in random number:" + numberOfTimes[h]);
               }


			proxy = null;
		}
		catch (Exception e) {
			Console.WriteLine (e);
		}
	}
}