using System;
using WebCab.Libraries.Statistics.PDistributions;

public class PoissonProbabilityDistributionClient {
	public static void Main () {
		try {
			PoissonProbabilityDistribution proxy = new PoissonProbabilityDistribution ();
						
			Console.WriteLine ("SetMean(10)");
			proxy.SetMean (10);

               Console.WriteLine ("Probability(0): " + proxy.Probability(0));

               for (int i=1; i<30;i++)
               {
                    Console.WriteLine ("Probability(" + i + "): " + proxy.Probability(i));
                    Console.WriteLine ("CumulativeProbability(" + i + "): " + proxy.CumulativeProbability(i));
               }

		
			Console.WriteLine ("ProbabilityUp(5): " + proxy.ProbabilityUp(5));
			Console.WriteLine ("GetMean(): " + proxy.GetMean());
			Console.WriteLine ("GetVariance(): " + proxy.GetVariance());
			Console.WriteLine ("Inverse(0.5): " + proxy.Inverse(0.5));
			Console.WriteLine ("GetRandomNumber():" + proxy.GetRandomNumber());


     	      // Create an arrray to store the number of times a given number of success is
			 // returned by the Poisson probability distribution's random number generator.
     	     int[] numberOfTimes = new int[30];

               for (int u =0; u<30;u++)
               {
                    numberOfTimes[u] = 0;
               }

               for (int j =1; j<800;j++)
               {
                    int k;
                    k = proxy.GetRandomNumber();
                    numberOfTimes[k] = numberOfTimes[k] +1;
               }

               for (int h=0; h < 30 ; h++){
                    Console.WriteLine("Number of " + h + "'s in random number:" + numberOfTimes[h]);
               }

			proxy = null;
		}
		catch (Exception e) {
			Console.WriteLine (e);
		}
	}
}