using System;
using WebCab.Lib.Util.Example;

using WebCab.Libraries.Statistics.DiscretePrb;

public class ProbabilityClient {
   public static void Main( String[] args ) {
      // used components
      Probability instanceOfProbability = new Probability();
      //
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "                      ######################################" );
      System.Console.WriteLine( "                      # Probability Console Client Example #" );
      System.Console.WriteLine( "                      ######################################" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " Overview" );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Here we provide  examples  for  the  methods  contained  within  the" );
      System.Console.WriteLine( "    Probability class." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Setting the Probability Measure +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    setProbability( int[] elementsOfSet," );
      System.Console.WriteLine( "                    double[] probabilityMeasure )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we demonstrate how we can set the probability  measure  of  the" );
      System.Console.WriteLine( "     set of four events,  identified  by;  1,  2,  3  and  4,  where  the" );
      System.Console.WriteLine( "     probability of each outcome is: 0.25, 0.2, 0.3, 0.25 respectively." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    elementsOfSet = {1, 2, 3, 4}" );
      System.Console.WriteLine( "    probabilityMeasure = {0.25, 0.2, 0.3, 0.25}" );
      // Here we set the probability measure.
      instanceOfProbability.SetProbability( 
         new int[] {1, 2, 3, 4}, // elementsOfSet
         new double[] {0.25, 0.2, 0.3, 0.25} // probabilityMeasure
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The probability measure in accordance with the above regards has  been" );
      System.Console.WriteLine( "    set." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Set the Probability Measure associated to an Experiment +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    setProbability( int numberOfEvents," );
      System.Console.WriteLine( "                    int[] occurrences )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here    we  set  the  probability  measure  in  accordance  with  an" );
      System.Console.WriteLine( "     experiment which has four outcomes denoted by: 1, 2, 3 and 4;  where" );
      System.Console.WriteLine( "     the number of occurrences of these outcome was found to  be:  5,  4," );
      System.Console.WriteLine( "     6, 5. Hence, the total number of events is: 5 + 4 + 6 + 5 = 20." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    numberOfEvents = 20" );
      System.Console.WriteLine( "    occurrences = {5, 4, 6, 5}" );
      // Here     we  set  the  probability  measure  in  accordance  with  the
      // experiment.
      instanceOfProbability.SetProbability( 
         20, // numberOfEvents
         new int[] {5, 4, 6, 5} // occurrences
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The associated probability measure of the experiment has been set." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Get set of reference numbers used +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    getSetOfProbability(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here is read off the reference numbers used for the  set  of  events" );
      System.Console.WriteLine( "     for which the probability measure is defined." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we set the probability measure which  describes  the  probability
      // of the different possible events taking place.
      instanceOfProbability.SetProbability( 
         new int[] {1, 2, 3, 4}, // elementsOfSet
         new double[] {0.25, 0.2, 0.3, 0.25} // probabilityMeasure
      );
      // Here we get the numbers used for  a  set  of  events  upon  which  the
      // probability measure has been set
      int[] getSetProb1 = instanceOfProbability.GetSetOfProbability( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The set of references numbers used are:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( getSetProb1, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Values of Probability measure set +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    getProbability(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we read off the values of the probability measure  on  the  set" );
      System.Console.WriteLine( "     for which it is defined." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we set the probability measure which  describes  the  probability
      // of the different possible events taking place.
      instanceOfProbability.SetProbability( 
         new int[] {1, 2, 3, 4}, // elementsOfSet
         new double[] {0.25, 0.2, 0.3, 0.25} // probabilityMeasure
      );
      // Here is read off the values of  the  probability  measure  which  have
      // been set.
      double[] getProb1 = instanceOfProbability.GetProbability( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The values of the probability measure of the set of events is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( getProb1, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate the Probability of a number of independent events +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    getProbability( int[] theEvent )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the probability of the 2nd or  3rd  of  the  events" );
      System.Console.WriteLine( "     occurring. Note that  the  2nd  and  3rd  event  of  assumed  to  be" );
      System.Console.WriteLine( "     independent." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    theEvent = {1, 2}" );
      // Here we set the probability measure which  describes  the  probability
      // of the different possible events taking place.
      instanceOfProbability.SetProbability( 
         new int[] {1, 2, 3, 4}, // elementsOfSet
         new double[] {0.25, 0.2, 0.3, 0.25} // probabilityMeasure
      );
      // Here we evaluate the probability of the 2nd and 3rd events  which  are
      // independent events (an assumption we make).
      double prob1 = instanceOfProbability.GetProbability( 
         new int[] {1, 2} // theEvent
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the probability of the 2nd or 3rd event occurring is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * prob1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Probability of Union of two collections of events +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probabilityUnion( int[] eventsA," );
      System.Console.WriteLine( "                      int[] eventsB )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    eventsA = {1, 2}" );
      System.Console.WriteLine( "    eventsB = {2, 4}" );
      // Here we set the probability measure which  describes  the  probability
      // of the different possible events taking place.
      instanceOfProbability.SetProbability( 
         new int[] {1, 2, 3, 4}, // elementsOfSet
         new double[] {0.25, 0.2, 0.3, 0.25} // probabilityMeasure
      );
      // Here we evaluate the probability of the union of  two  collections  of
      // events occuring.
      double probUnion1 = instanceOfProbability.ProbabilityUnion( 
         new int[] {1, 2}, // eventsA
         new int[] {2, 4} // eventsB
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The probability of an event from the union of the two  collections  of" );
      System.Console.WriteLine( "    events is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * probUnion1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Probability of Intersection of two collections of events +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probabilityIntersection( int[] eventsA," );
      System.Console.WriteLine( "                             int[] eventsB )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    eventsA = {1, 2}" );
      System.Console.WriteLine( "    eventsB = {2, 4}" );
      // Here we set the probability measure which  describes  the  probability
      // of the different possible events taking place.
      instanceOfProbability.SetProbability( 
         new int[] {1, 2, 3, 4}, // elementsOfSet
         new double[] {0.25, 0.2, 0.3, 0.25} // probabilityMeasure
      );
      // Here    we  evaluate  the  probability  of  the  intersection  of  two
      // collections of events.
      double probInter1 = instanceOfProbability.ProbabilityIntersection( 
         new int[] {1, 2}, // eventsA
         new int[] {2, 4} // eventsB
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The  probability  of  an  event  from  the  intersection  of  the  two" );
      System.Console.WriteLine( "    collections of events is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * probInter1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluation of the Conditional Probability +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    conditionalProbability( int[] eventsA," );
      System.Console.WriteLine( "                            int[] eventsB )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    eventsA = {1, 3}" );
      System.Console.WriteLine( "    eventsB = {1, 4}" );
      // Here we set the probability measure which  describes  the  probability
      // of the different possible events taking place.
      instanceOfProbability.SetProbability( 
         new int[] {1, 2, 3, 4}, // elementsOfSet
         new double[] {0.2, 0.3, 0.4, 0.1} // probabilityMeasure
      );
      // Here we evaluate the conditional probability.
      double probIntersection1 = instanceOfProbability.ConditionalProbability( 
         new int[] {1, 3}, // eventsA
         new int[] {1, 4} // eventsB
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The conditional probability is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * probIntersection1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluation of the Complementary Probability +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    complementaryProbability( int[] eventsA )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    eventsA = {1}" );
      // Here we set the probability measure which  describes  the  probability
      // of the different possible events taking place.
      instanceOfProbability.SetProbability( 
         new int[] {1, 2, 3, 4}, // elementsOfSet
         new double[] {0.2, 0.3, 0.4, 0.1} // probabilityMeasure
      );
      // Here we evaluate the complementary probability of the 1st  event  from
      // a set of four possible events.
      double probComple1 = instanceOfProbability.ComplementaryProbability( 
         new int[] {1} // eventsA
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The complementary probability of the 1st event is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * probComple1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Find probability using Intersection Law +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    eventProbability( double probabilityOfB," );
      System.Console.WriteLine( "                      double probabilityOfUnion," );
      System.Console.WriteLine( "                      double probabilityOfIntersection )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the complementary probability of the  1st  possible" );
      System.Console.WriteLine( "     event of a total of four possible events where  the  probability  of" );
      System.Console.WriteLine( "     each event is:" );
      System.Console.WriteLine( "     What is the probability of  a  collection  of  events  A,  when  the" );
      System.Console.WriteLine( "     probability of another collection  of  events  B  is  0.5,  and  the" );
      System.Console.WriteLine( "     probability of the union of the events in A and B  is  known  to  be" );
      System.Console.WriteLine( "     0.7, and the intersection of the two sets of events is A and  B,  is" );
      System.Console.WriteLine( "     0.1." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probabilityOfB = 0.5" );
      System.Console.WriteLine( "    probabilityOfUnion = 0.7" );
      System.Console.WriteLine( "    probabilityOfIntersection = 0.1" );
      // Here we find the probability of  a  collection  of  events  using  the
      // intersection law.
      double probIntersection2 = instanceOfProbability.EventProbability( 
         0.5, // probabilityOfB
         0.7, // probabilityOfUnion
         0.1 // probabilityOfIntersection
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The probability of the set of events A, is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * probIntersection2 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Find the Probability of the Union using the Intersection Law +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probabilityOfUnion( double probabilityOfA," );
      System.Console.WriteLine( "                        double probabilityOfB," );
      System.Console.WriteLine( "                        double probIntersection )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the probability of the union of two collections of events  A" );
      System.Console.WriteLine( "     and B, when  the  probability  of  the  event  A  is  0.3,  and  the" );
      System.Console.WriteLine( "     probability of the event B  is  0.4,  and  the  probability  of  the" );
      System.Console.WriteLine( "     intersection is 0.1." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probabilityOfA = 0.3" );
      System.Console.WriteLine( "    probabilityOfB = 0.4" );
      System.Console.WriteLine( "    probIntersection = 0.1" );
      // Here we evaluate the probability of the union of  two  collections  of
      // events using the intersection law.
      double probUnionIntersection1 = instanceOfProbability.ProbabilityOfUnion( 
         0.3, // probabilityOfA
         0.4, // probabilityOfB
         0.1 // probIntersection
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The probability of the union is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * probUnionIntersection1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( " " );
   }
}
