using System;
using WebCab.Lib.Util.Example;

using WebCab.Libraries.Statistics.PDistributions;

public class WeibullProbabilityDistributionClient {
   public static void Main( String[] args ) {
      // used components
      WeibullProbabilityDistribution instanceOfWeibullProbabilityDistribution = new WeibullProbabilityDistribution();
      //
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "            #########################################################" );
      System.Console.WriteLine( "            # WeibullProbabilityDistribution Console Client Example #" );
      System.Console.WriteLine( "            #########################################################" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " Overview" );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Here we offer an example for each of the  public  methods  contained" );
      System.Console.WriteLine( "    within the WeibullProbabilityDistribution." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++" );
      System.Console.WriteLine( "+ Setting the Shape +" );
      System.Console.WriteLine( "+++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    setShape( double shape )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we set the Shape parameter to 5." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    shape = 5" );
      // Here we set the Shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The Shape parameter has now been set." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Get the Shape Parameter +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    getShape(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we get the Shape parameter which has just been set to 5." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here we get the Shape parameter.
      double getShape1 = instanceOfWeibullProbabilityDistribution.GetShape( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The Shape parameter is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * getShape1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Setting the Location and Scale Parameters +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    setGeneral( double location," );
      System.Console.WriteLine( "                double scale )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we set the location parameter to 2, and the scale parameter  to" );
      System.Console.WriteLine( "     3, for the General Weibull probability distribution." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    location = 2" );
      System.Console.WriteLine( "    scale = 3" );
      // Here we set the location and scale parameters
      instanceOfWeibullProbabilityDistribution.SetGeneral( 
         2.0, // location
         3.0 // scale
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The location and scale parameter has now been set." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Getting the Location Parameter +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    getLocation(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we get the value of  the  location  parameter  of  the  General" );
      System.Console.WriteLine( "     Weibull Probability Distribution which has just been set." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we set the location and scale parameters
      instanceOfWeibullProbabilityDistribution.SetGeneral( 
         2.0, // location
         3.0 // scale
      );
      // Here we get the location parameter.
      double getLocation1 = instanceOfWeibullProbabilityDistribution.GetLocation( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the location parameter is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * getLocation1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Getting the Scale Parameter +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    getScale(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we get the value of the scale parameter of the General  Weibull" );
      System.Console.WriteLine( "     Probability Distribution which has just been set." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we set the location and scale parameters
      instanceOfWeibullProbabilityDistribution.SetGeneral( 
         2.0, // location
         3.0 // scale
      );
      // Here we get the scale parameter.
      double getScale1 = instanceOfWeibullProbabilityDistribution.GetScale( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the scale parameter is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * getScale1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate the Probability Density  Function  of  the  Standard  Weibull +" );
      System.Console.WriteLine( "+ Probability distribution                                               +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probDensity( double evaluationPoint )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the Probability Density  function  of  the  Weibull" );
      System.Console.WriteLine( "     Probability Distribution at the point 1." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    evaluationPoint = 1" );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here we set the location and scale parameters
      instanceOfWeibullProbabilityDistribution.SetGeneral( 
         2.0, // location
         3.0 // scale
      );
      // Here we evaluate the  Probability  Density  function  of  the  Weibull
      // Probability Distribution set.
      double probDensity1 = instanceOfWeibullProbabilityDistribution.ProbDensity( 
         1.0 // evaluationPoint
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the Probability Density function at the point 1, is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * probDensity1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate the Probability  Density  Function  of  the  General  Weibull +" );
      System.Console.WriteLine( "+ Probability distribution                                               +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probDensityGen( double evaluationPoint )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the Probability Density  function  of  the  General" );
      System.Console.WriteLine( "     Weibull Probability Distribution which has been set at the point 1." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    evaluationPoint = 1" );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here we set the location and scale parameters
      instanceOfWeibullProbabilityDistribution.SetGeneral( 
         2.0, // location
         3.0 // scale
      );
      // Here we evaluate the  Probability  Density  function  of  the  General
      // Weibull Probability distribution which has been set.
      double probDensity2 = instanceOfWeibullProbabilityDistribution.ProbDensityGen( 
         1.0 // evaluationPoint
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the Probability Density function at the point 1, is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * probDensity2 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Cumulative Distribution +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    cumulativeDist( double evaluationPoint )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here  we  evaluate  the  Cumulative  Distribution  function  of  the" );
      System.Console.WriteLine( "     Weibull Probability distribution at the point 1." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    evaluationPoint = 1" );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here we evaluate the Cumulative Distribution function of  the  Weibull
      // Probability distribution.
      double cumDis1 = instanceOfWeibullProbabilityDistribution.CumulativeDist( 
         1.0 // evaluationPoint
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the Cumulative Distribution function at the point 1, is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * cumDis1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Cumulative Distribution General +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    cumulativeDistGen( double evaluationPoint )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here  we  evaluate  the  Cumulative  Distribution  function  of  the" );
      System.Console.WriteLine( "     General Weibull Probability distribution just set at the point 1." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    evaluationPoint = 1" );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here we set the location and scale parameters
      instanceOfWeibullProbabilityDistribution.SetGeneral( 
         2.0, // location
         3.0 // scale
      );
      // Here we evaluate the Cumulative Distribution function for the  General
      // Weibull Probability distribution set.
      double cumDisGen1 = instanceOfWeibullProbabilityDistribution.CumulativeDistGen( 
         1.0 // evaluationPoint
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the cumulative probability distribution is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * cumDisGen1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++" );
      System.Console.WriteLine( "+ Percent Point +" );
      System.Console.WriteLine( "+++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    percentPoint( double percent )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     We evaluated the Percent point function of the  Weibull  Probability" );
      System.Console.WriteLine( "     function   at  50  percent  for  the  Standard  Weibull  Probability" );
      System.Console.WriteLine( "     function set with shape parameter 5." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    percent = 0.5" );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here    we  evaluated  the  percent  point  function  of  the  Weibull
      // Probability Function set.
      double percent1 = instanceOfWeibullProbabilityDistribution.PercentPoint( 
         0.5 // percent
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the Percent Point function at 50 percent is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * percent1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Percent Point General +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    percentPointGen( double percent )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Evaluate the value of the Percent Point  function  for  the  General" );
      System.Console.WriteLine( "     Weibull Probability distribution at 50  percent,  where  the  shape," );
      System.Console.WriteLine( "     location and scale parameters take the values 5, 2, 3 respectively." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    percent = 0.5" );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here we set the location and scale parameters
      instanceOfWeibullProbabilityDistribution.SetGeneral( 
         2.0, // location
         3.0 // scale
      );
      // Here we evaluate  the  Percent  Point  from  of  the  General  Weibull
      // Probability function set.
      double percentGen1 = instanceOfWeibullProbabilityDistribution.PercentPointGen( 
         0.5 // percent
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the Percent Point function at 50 percent for the  General" );
      System.Console.WriteLine( "    Weibull Probability function set is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * percentGen1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++" );
      System.Console.WriteLine( "+ Hazard Function +" );
      System.Console.WriteLine( "+++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    hazard( double evaluationPoint )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Evaluate the Hazard function for the  Standard  Weibull  Probability" );
      System.Console.WriteLine( "     function with a Shape Parameter of 5, at the point 1." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    evaluationPoint = 1" );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Evaluate the Hazard function  for  the  Standard  Weibull  Probability
      // function with a Shape Parameter of 5, at the point 1.
      double hazard1 = instanceOfWeibullProbabilityDistribution.Hazard( 
         1.0 // evaluationPoint
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the Hazard function is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * hazard1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Hazard Function General +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    hazardGen( double evaluationPoint )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Evaluate the Hazard function for  the  General  Weibull  Probability" );
      System.Console.WriteLine( "     function at the  point  1,  where  the  shape,  location  and  scale" );
      System.Console.WriteLine( "     parameters take the values 5, 2, 3 respectively." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    evaluationPoint = 1" );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here we set the location and scale parameters
      instanceOfWeibullProbabilityDistribution.SetGeneral( 
         2.0, // location
         3.0 // scale
      );
      // Calculate the Hazard  function  of  the  General  Weibull  Probability
      // function set at 1.
      double hazardGen1 = instanceOfWeibullProbabilityDistribution.HazardGen( 
         1.0 // evaluationPoint
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the Hazard function is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * hazardGen1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Cumulative Hazard Function +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    cumulHazard( double evaluationPoint )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Evaluate the Cumulative Hazard function for the Weibull  Probability" );
      System.Console.WriteLine( "     Distribution with a shape parameter of 5, at the point 1." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    evaluationPoint = 1" );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Evaluate the Cumulative Hazard function for  the  Weibull  Probability
      // Distribution with a shape parameter of 5, at the point 1.
      double cumulHazard1 = instanceOfWeibullProbabilityDistribution.CumulHazard( 
         1.0 // evaluationPoint
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the Cumulative Hazard Function is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * cumulHazard1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Cumulative Hazard Function General +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    cumulHazardGen( double evaluationPoint )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Evaluate the Cumulative Hazard  function  for  the  General  Weibull" );
      System.Console.WriteLine( "     Probability Distribution at the point 1, where the  shape,  location" );
      System.Console.WriteLine( "     and scale parameters are 5, 2, 3 respectively." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    evaluationPoint = 5" );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here we set the location and scale parameters
      instanceOfWeibullProbabilityDistribution.SetGeneral( 
         2.0, // location
         3.0 // scale
      );
      // Evaluate the  Cumulative  Hazard  function  for  the  General  Weibull
      // Probability Distribution at the point 1,  where  the  shape,  location
      // and scale parameters are 5, 2, 3 respectively.
      double cumulativeHazardGen1 = instanceOfWeibullProbabilityDistribution.CumulHazardGen( 
         5.0 // evaluationPoint
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the Cumulative Hazard function is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * cumulativeHazardGen1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++" );
      System.Console.WriteLine( "+ Survival Function +" );
      System.Console.WriteLine( "+++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    survival( double evaluationPoint )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the  Survival  Function  of  the  Standard  Weibull" );
      System.Console.WriteLine( "     distribution with a shape parameter of 5, at the point 1." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    evaluationPoint = 1" );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here we evaluate the survival function at 1.
      double survival1 = instanceOfWeibullProbabilityDistribution.Survival( 
         1.0 // evaluationPoint
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the survival function is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * survival1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Survival Function General +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    survivalGen( double evaluationPoint )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate  the  Survival  Function  of  the  General  Weibull" );
      System.Console.WriteLine( "     Probability distribution with shape, location and  scale  parameters" );
      System.Console.WriteLine( "     of 5, 2, 3, respectively; at the point 1." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    evaluationPoint = 1" );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here we set the location and scale parameters
      instanceOfWeibullProbabilityDistribution.SetGeneral( 
         2.0, // location
         3.0 // scale
      );
      // Here  we  evaluate  the  Survival  Function  of  the  General  Weibull
      // distribution wich has just been set.
      double survivalGen1 = instanceOfWeibullProbabilityDistribution.SurvivalGen( 
         1.0 // evaluationPoint
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the Survival Function is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * survivalGen1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Inverse Survival Function +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    inverseSurvival( double percent )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     We evaluate the Inverse Survival Function for the Standard  Survival" );
      System.Console.WriteLine( "     function at the 50 percent level." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    percent = 0.50" );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here we evaluate the Inverse  Survival  function  at  the  50  percent
      // level.
      double inverseSurvival1 = instanceOfWeibullProbabilityDistribution.InverseSurvival( 
         0.50 // percent
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the Inverse Survival function at  the  50  percent  level" );
      System.Console.WriteLine( "    is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * inverseSurvival1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Inverse Survival Function General +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    inverseSurvivalGen( double percent )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the Inverse Survival function of a General  Weibull" );
      System.Console.WriteLine( "     Probability distribution at the 50 percent level, where  the  shape," );
      System.Console.WriteLine( "     location and scale parameters at 5, 2, 3, respectively." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    percent = 0.50" );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here we set the location and scale parameters
      instanceOfWeibullProbabilityDistribution.SetGeneral( 
         2.0, // location
         3.0 // scale
      );
      // Here we evaluate the Inverse Survival function of  a  General  Weibull
      // Probability distribution at the 50 percent level.
      double inverseSurvivalGen1 = instanceOfWeibullProbabilityDistribution.InverseSurvivalGen( 
         0.50 // percent
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the Inverse Survival function are:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * inverseSurvivalGen1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Mean of Standard Weibull Probability distribution +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    mean(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate  the  mean  of  the  Standard  Weibull  Probability" );
      System.Console.WriteLine( "     distribution with a shape parameter of 5:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here  we  evaluate  the  mean  of  the  Standard  Weibull  Probability
      // distribution.
      double mean1 = instanceOfWeibullProbabilityDistribution.Mean( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The mean of the Standard Weibull Distribution is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * mean1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Median of the Standard Weibull Probability Distribution +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    median(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the median  of  the  Standard  Weibull  Probability" );
      System.Console.WriteLine( "     Distribution where a shape parameter of 5." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here we evaluate the median of the Weibull Probability Distribution.
      double median1 = instanceOfWeibullProbabilityDistribution.Median( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The median of the Weibull distribution is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * median1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Mode of the Standard Weibull Probability Distribution +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    mode(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate  the  mode  of  the  Standard  Weibull  Probability" );
      System.Console.WriteLine( "     distribution with a shape parameter of 5." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here  we  evaluate  the  mode  of  the  Standard  Weibull  Probability
      // distribution.
      double mode1 = instanceOfWeibullProbabilityDistribution.Mode( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The mode of the Weibull probability distribution is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * mode1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Standard Deviation of the Weibull Distribution +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    standardDeviation(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the standard deviation of the Weibull  Distribution" );
      System.Console.WriteLine( "     when the shape parameter is 5." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here we evaluate the standard deviation of the Weibull distribution.
      double standDev1 = instanceOfWeibullProbabilityDistribution.StandardDeviation( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The standard deviation of the Weibull distribution is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * standDev1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Coefficient of Variation of the SWeibull Distribution +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    coeffVariation(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we  evaluate  the  coefficient  of  variation  of  the  Weibull" );
      System.Console.WriteLine( "     Distribution with a shape parameter of 5." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we set the shape parameter.
      instanceOfWeibullProbabilityDistribution.SetShape( 
         5.0 // shape
      );
      // Here  we  evaluated  the  coefficient  of  variation  of  the  WEibull
      // distribution.
      double coeffOfVariation1 = instanceOfWeibullProbabilityDistribution.CoeffVariation( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The coefficient of variation is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * coeffOfVariation1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( " " );
   }
}
