Imports System
Imports WebCab.Lib.Util.Example
Imports WebCab.Libraries.Statistics.Correlation

Module CoupleClient
   Sub Main()
      ' used components
      Dim instanceOfCorrelationStateful As WebCab.Libraries.Statistics.Correlation.CorrelationStateful = New WebCab.Libraries.Statistics.Correlation.CorrelationStateful
      '
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "                        #################################" )
      System.Console.WriteLine( "                        # Couple Console Client Example #" )
      System.Console.WriteLine( "                        #################################" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " Overview" )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    Within this client example we will  illustrate  the  effect  of  the" )
      System.Console.WriteLine( "    addition of further data points to the  Correlation  measures  which" )
      System.Console.WriteLine( "    we offer." )
      System.Console.WriteLine( "    Within this Client we study the relationship between the  height  of" )
      System.Console.WriteLine( "    a wife and the height of her husband. If we assume  that  the  joint" )
      System.Console.WriteLine( "    distribution  of  heights  of  married  couples  can  be  reasonably" )
      System.Console.WriteLine( "    approximated      by  a  bivariate  normal  distribution,  then  the" )
      System.Console.WriteLine( "    relationship   of  interest  can  be  summarized  by  a  correlation" )
      System.Console.WriteLine( "    coefficient. In order to investigate this relationship, a sample  of" )
      System.Console.WriteLine( "    15 American couples was drawn at random, and the resulting data  are" )
      System.Console.WriteLine( "    shown in the table below:" )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "       - Couple #1: Wife's Height 70: Husband's Height 75" )
      System.Console.WriteLine( "       - Couple #2: Wife's Height 67: Husband's Height 72" )
      System.Console.WriteLine( "       - Couple #3: Wife's Height 70: Husband's Height 75" )
      System.Console.WriteLine( "       - Couple #4: Wife's Height 71: Husband's Height 76" )
      System.Console.WriteLine( "       - Couple #5: Wife's Height 67: Husband's Height 70" )
      System.Console.WriteLine( "       - Couple #6: Wife's Height 64: Husband's Height 68" )
      System.Console.WriteLine( "       - Couple #7: Wife's Height 71: Husband's Height 72" )
      System.Console.WriteLine( "       - Couple #8: Wife's Height 63: Husband's Height 67" )
      System.Console.WriteLine( "       - Couple #9: Wife's Height 65: Husband's Height 67" )
      System.Console.WriteLine( "       - Couple #10: Wife's Height 64: Husband's Height 68" )
      System.Console.WriteLine( "       - Couple #11: Wife's Height 65: Husband's Height 68" )
      System.Console.WriteLine( "       - Couple #12: Wife's Height 65: Husband's Height 71" )
      System.Console.WriteLine( "       - Couple #13: Wife's Height 66: Husband's Height 68" )
      System.Console.WriteLine( "       - Couple #14: Wife's Height 65: Husband's Height 71" )
      System.Console.WriteLine( "       - Couple #15: Wife's Height 61: Husband's Height 62" )
      System.Console.WriteLine( "       " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "    For this set we will first evaluate the mean  and  variance,  before" )
      System.Console.WriteLine( "    evaluating the three main Correlation measures." )
      System.Console.WriteLine( "    Then we will add three more points (i.e. couples) to  the  data  set" )
      System.Console.WriteLine( "    and recalculate the sames  statistics  in  order  to  ascertain  the" )
      System.Console.WriteLine( "    effect of the addition of the three data points. The  data  we  will" )
      System.Console.WriteLine( "    add will shrink the correlation coefficient. The data  we  will  add" )
      System.Console.WriteLine( "    is as follows:" )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( "       - Couple# 16: Wife's Height 60: Husband's Height 72" )
      System.Console.WriteLine( "       - Couple# 17: Wife's Height 72: Husband's Height 62" )
      System.Console.WriteLine( "       - Couple# 18: Wife's Height 72: Husband's Height 68" )
      System.Console.WriteLine( "       " )
      System.Console.WriteLine( "    " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Addding the first 15 Couples +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    addValues( double[] xValues," )
      System.Console.WriteLine( "               double[] yValues )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we add the first 15 couples to  the  present  instance  of  the" )
      System.Console.WriteLine( "     Correlation class." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    xValues = {70.0, 67.0, 70.0, 71.0, 67.0, 64.0, 71.0, 63.0, 65.0, 64.0, 65.0, 65.0, 66.0, 65.0, 61.0}" )
      System.Console.WriteLine( "    yValues = {75.0, 72.0, 75.0, 76.0, 70.0, 68.0, 72.0, 67.0, 67.0, 68.0, 68.0, 71.0, 68.0, 71.0, 62.0}" )
      ' Here we add the firat 15 couples to the instance  in  order  to  study
      ' there properties.
      instanceOfCorrelationStateful.AddValues( _
         New Double() {70.0, 67.0, 70.0, 71.0, 67.0, 64.0, 71.0, 63.0, 65.0, 64.0, 65.0, 65.0, 66.0, 65.0, 61.0}, _
         New Double() {75.0, 72.0, 75.0, 76.0, 70.0, 68.0, 72.0, 67.0, 67.0, 68.0, 68.0, 71.0, 68.0, 71.0, 62.0} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The first 15 couples have now been set to the present instance of  the" )
      System.Console.WriteLine( "    class." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation of the Pearson's Correlation Coefficient +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    pearsonCorrelationCoefficient(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the Pearson's Correlation Coefficient  between  the" )
      System.Console.WriteLine( "     heights of the husband and wife, of the 15 couples. Note, that  this" )
      System.Console.WriteLine( "     coefficient will lie within the range  [-1,1],  where  -1  indicates" )
      System.Console.WriteLine( "     that the results in perfectly negatively correlated and 1  indicates" )
      System.Console.WriteLine( "     that the results are perfectly correlated." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' Here we evaluate Pearson's Correlation Coefficient for  the  first  15
      ' couples.
      Dim pearson1 As Double = instanceOfCorrelationStateful.PearsonCorrelationCoefficient( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The Pearson's Correlation Coefficient between the couples heights  for" )
      System.Console.WriteLine( "    the 15 couples is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * pearson1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the Significance Test for Pearson's +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    significance( double correlationCoefficient )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate  the  Significance  test  for  the  result  of  the" )
      System.Console.WriteLine( "     Pearson's Correlation Coefficient evaluated above." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    correlationCoefficient = pearson1" )
      ' Here we  evaluate  the  significance  test  of  the  result  found  by
      ' Pearson's Correlation Coefficient.
      Dim sig1 As Double = instanceOfCorrelationStateful.Significance( _
         pearson1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The significant test for the result  found  by  Pearson's  Correlation" )
      System.Console.WriteLine( "    Coefficient is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * sig1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation of the Spearman's Rank Correlation Coefficient +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    spearmanRankTest(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here   we  evaluate  the  Spearman's  Rank  Correlation  Coefficient" )
      System.Console.WriteLine( "     between the heights of the 15 couples." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' Here we evaluate  Spearman's  Rank  Correlation  Coefficient  for  the
      ' couples heights.
      Dim rank1 As Double = instanceOfCorrelationStateful.SpearmanRankTest( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The value of the Spearman's Rank Correlation Coefficient is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * rank1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate   the  Significance  Test  for  Spearman's  Rank  Correlation +" )
      System.Console.WriteLine( "+ Coefficient                                                            +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    significance( double correlationCoefficient )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate  the  Significance  test  for  the  result  of  the" )
      System.Console.WriteLine( "     Spearman's Rank Correlation Coefficient evaluated above." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    correlationCoefficient = rank1" )
      ' Here we  evaluate  the  significance  test  of  the  result  found  by
      ' Spearman's Rank Correlation Coefficient.
      Dim sig2 As Double = instanceOfCorrelationStateful.Significance( _
         rank1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The   significant  test  for  the  result  found  by  Spearman's  Rank" )
      System.Console.WriteLine( "    Correlation Coefficient is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * sig2, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Kendall's Correlation Coefficient +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    kendallCorrelationCoefficient(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate Kendall's Correlation Coefficient between  the  two" )
      System.Console.WriteLine( "     heights of the 15 couples." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' Here we evaluate Kendall's Correlation  Coefficient  for  the  couples
      ' heights.
      Dim ken1 As Double = instanceOfCorrelationStateful.KendallCorrelationCoefficient( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    Kendall's Correlation  Coefficient  between  the  heights  of  the  15" )
      System.Console.WriteLine( "    couples is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * ken1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Average Height of the Wives within the 15 Couples +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    meanX(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluated average height of the wives within the 15  couples" )
      System.Console.WriteLine( "     considered." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' Here we evaluated the average  height  of  the  wives  within  the  15
      ' couples considered.
      Dim meanWives15 As Double = instanceOfCorrelationStateful.MeanX( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The average height of the wives is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * meanWives15, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Average Height of the Husbands within the 15 Couples +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    meanY(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the average height of the husbands  within  the  15" )
      System.Console.WriteLine( "     couples considered." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' Here we evaluated the average height of the  husbands  within  the  15
      ' couples.
      Dim meanHusband15 As Double = instanceOfCorrelationStateful.MeanY( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The average height of the husbands is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * meanHusband15, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Variance of the Wives within the 15 Couples +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    sampleVarianceX(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the variance of the heights  of  the  wives  within" )
      System.Console.WriteLine( "     the 15 couples considered." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' He we evaluate the variance of the wives within the 15 couples.
      Dim variance15Wives As Double = instanceOfCorrelationStateful.SampleVarianceX( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The variance of the heights of the wives is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * variance15Wives, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Variance of the Husbands within the 15 Couples +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    sampleVarianceY(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the variance of the heights of the husbands  within" )
      System.Console.WriteLine( "     the 15 couples considered." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' He we evaluate the variamce of the husbands within the 15 couples.
      Dim variance15Husbands As Double = instanceOfCorrelationStateful.SampleVarianceY( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The variance of the heights of the husbands is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * variance15Husbands, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Adding the final three Couples +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    addValues( double[] xValues," )
      System.Console.WriteLine( "               double[] yValues )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we add  the  final  three  couples  to  the  collection  of  15" )
      System.Console.WriteLine( "     couples, to bring the total  number  of  couples  considered  to  18" )
      System.Console.WriteLine( "     couples." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    xValues = {60.0, 72.0, 72.0}" )
      System.Console.WriteLine( "    yValues = {72.0, 62.0, 68.0}" )
      ' Here we add the final three couple.
      instanceOfCorrelationStateful.AddValues( _
         New Double() {60.0, 72.0, 72.0}, _
         New Double() {72.0, 62.0, 68.0} _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The three addition couples  have  now  been  set  within  the  private" )
      System.Console.WriteLine( "    fields." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation  of  the  Pearson's  Correlation  Coefficient  for  the  18 +" )
      System.Console.WriteLine( "+ Couples                                                                +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    pearsonCorrelationCoefficient(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the Pearson's Correlation Coefficient  between  the" )
      System.Console.WriteLine( "     heights of the husband and wife, of the 18 couples. Note, that  this" )
      System.Console.WriteLine( "     coefficient will lie within the range  [-1,1],  where  -1  indicates" )
      System.Console.WriteLine( "     that the results in perfectly negatively correlated and 1  indicates" )
      System.Console.WriteLine( "     that the results are perfectly correlated." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' Here   we  evaluate  Pearson's  Correlation  Coefficient  for  the  18
      ' couples.
      Dim pearson2 As Double = instanceOfCorrelationStateful.PearsonCorrelationCoefficient( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The Pearson's Correlation Coefficient between the couples heights  for" )
      System.Console.WriteLine( "    the 18 couples is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * pearson2, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the Significance Test for Pearson's for the 18 Couples +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    significance( double correlationCoefficient )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate  the  Significance  test  for  the  result  of  the" )
      System.Console.WriteLine( "     Pearson's Correlation Coefficient evaluated above." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    correlationCoefficient = pearson1" )
      ' Here we  evaluate  the  significance  test  of  the  result  found  by
      ' Pearson's Correlation Coefficient.
      Dim sig3 As Double = instanceOfCorrelationStateful.Significance( _
         pearson1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The significant test for the result  found  by  Pearson's  Correlation" )
      System.Console.WriteLine( "    Coefficient is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * sig3, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluation of the Spearman's Rank Correlation Coefficient for  the  18 +" )
      System.Console.WriteLine( "+ Couples                                                                +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    spearmanRankTest(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here   we  evaluate  the  Spearman's  Rank  Correlation  Coefficient" )
      System.Console.WriteLine( "     between the heights of the 18 couples." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' Here we evaluate  Spearman's  Rank  Correlation  Coefficient  for  the
      ' couples heights.
      Dim rank2 As Double = instanceOfCorrelationStateful.SpearmanRankTest( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The value of the Spearman's Rank Correlation Coefficient is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * rank2, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate   the  Significance  Test  for  Spearman's  Rank  Correlation +" )
      System.Console.WriteLine( "+ Coefficient for the 18 Couples                                         +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    significance( double correlationCoefficient )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate  the  Significance  test  for  the  result  of  the" )
      System.Console.WriteLine( "     Spearman's Rank Correlation Coefficient evaluated above." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    correlationCoefficient = rank1" )
      ' Here we  evaluate  the  significance  test  of  the  result  found  by
      ' Spearman's Rank Correlation Coefficient.
      Dim sig4 As Double = instanceOfCorrelationStateful.Significance( _
         rank1 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The   significant  test  for  the  result  found  by  Spearman's  Rank" )
      System.Console.WriteLine( "    Correlation Coefficient is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * sig4, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Kendall's Correlation Coefficient for the 18 Couples +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    kendallCorrelationCoefficient(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate Kendall's Correlation Coefficient between  the  two" )
      System.Console.WriteLine( "     heights of the 18 couples." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' Here we evaluate Kendall's Correlation  Coefficient  for  the  couples
      ' heights.
      Dim ken2 As Double = instanceOfCorrelationStateful.KendallCorrelationCoefficient( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    Kendall's Correlation  Coefficient  between  the  heights  of  the  18" )
      System.Console.WriteLine( "    couples is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * ken2, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Average Height of the Wives within the 18 Couples +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    meanX(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluated average height of the wives within the 18  couples" )
      System.Console.WriteLine( "     considered." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' Here we evaluated the average  height  of  the  wives  within  the  18
      ' couples considered.
      Dim meanWives18 As Double = instanceOfCorrelationStateful.MeanX( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The average height of the wives is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * meanWives18, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Average Height of the Husbands within the 18 Couples +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    meanY(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the average height of the husbands  within  the  18" )
      System.Console.WriteLine( "     couples considered." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' Here we evaluated the average height of the  husbands  within  the  18
      ' couples.
      Dim meanHusband18 As Double = instanceOfCorrelationStateful.MeanY( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The average height of the husbands is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * meanHusband18, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Variance of the Wives within the 18 Couples +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    sampleVarianceX(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the variance of the heights  of  the  wives  within" )
      System.Console.WriteLine( "     the 18 couples considered." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' He we evaluate the variance of the wives within the 18 couples.
      Dim variance18Wives As Double = instanceOfCorrelationStateful.SampleVarianceX( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The variance of the heights of the wives is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * variance18Wives, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Variance of the Husbands within the 15 Couples +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    sampleVarianceY(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the variance of the heights of the husbands  within" )
      System.Console.WriteLine( "     the 18 couples considered." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' He we evaluate the variamce of the husbands within the 18 couples.
      Dim variance18Husbands As Double = instanceOfCorrelationStateful.SampleVarianceY( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The variance of the heights of the husbands is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * variance18Husbands, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( " " )
   End Sub
End Module

