Imports System
Imports WebCab.Lib.Util.Example
Imports WebCab.Libraries.Statistics.Hypothesis

Module StudentConfidenceClient
   Sub Main()
      ' used components
      Dim instanceOfStudentConfidence As WebCab.Libraries.Statistics.Hypothesis.StudentConfidence = New WebCab.Libraries.Statistics.Hypothesis.StudentConfidence
      '
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "                   ############################################" )
      System.Console.WriteLine( "                   # StudentConfidence Console Client Example #" )
      System.Console.WriteLine( "                   ############################################" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " Overview" )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    Within this client we illustrate  the  application  of  the  methods" )
      System.Console.WriteLine( "    contained within the StudentConfidence class. Within each  of  these" )
      System.Console.WriteLine( "    examples we evaluate to a given degree of  confidence  the  interval" )
      System.Console.WriteLine( "    (i.e. confidence interval) a statistic of the entire population  (or" )
      System.Console.WriteLine( "    other samples from the population) when the same statistics is  know" )
      System.Console.WriteLine( "    for a small sample from that population." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evalutes the confidence interval of the mean +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    meanConfidence( int sampleSize," )
      System.Console.WriteLine( "                    double mean," )
      System.Console.WriteLine( "                    double standardDeviation," )
      System.Console.WriteLine( "                    double significanceLevel )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     For a sample group of 15 people with an  average  height  of  165cm," )
      System.Console.WriteLine( "     and a standard deviation of the heights of 10cm, we evaluate the  95" )
      System.Console.WriteLine( "     percent confidence interval. That is, we evaluate  the  interval  in" )
      System.Console.WriteLine( "     which the mean of the heights of  the  entire  population  to  a  95" )
      System.Console.WriteLine( "     percent confidence interval is expected to lie." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    sampleSize = 15" )
      System.Console.WriteLine( "    mean = 165" )
      System.Console.WriteLine( "    standardDeviation = 10" )
      System.Console.WriteLine( "    significanceLevel = 95" )
      ' Here we evaluate the confidence interval of the mean.
      Dim mean1 As Double() = instanceOfStudentConfidence.MeanConfidence( _
         15, _
         165.0, _
         10.0, _
         95.0 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The confidence interval of the mean is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( mean1, ", " ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Confidence Interval for the difference between two means +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    meansDifference( int size1," )
      System.Console.WriteLine( "                     int size2," )
      System.Console.WriteLine( "                     double mean1," )
      System.Console.WriteLine( "                     double mean2," )
      System.Console.WriteLine( "                     double standardDeviation1," )
      System.Console.WriteLine( "                     double standardDeviation2," )
      System.Console.WriteLine( "                     double significanceLevel )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here   we  evaluate  the  95  percent  confidence  interval  of  the" )
      System.Console.WriteLine( "     difference between the  means  of  two  samples  selected  from  the" )
      System.Console.WriteLine( "     entire population, where for the two samples selected we have:" )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( "        - Sample 1: Size = 20, Mean of sample = 165,  Standard  deviation" )
      System.Console.WriteLine( "        of sample = 3" )
      System.Console.WriteLine( "        - Sample 2: Size = 15, Mean of sample = 168,  Standard  deviation" )
      System.Console.WriteLine( "        of sample = 3.4" )
      System.Console.WriteLine( "        " )
      System.Console.WriteLine( "     " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    size1 = 20" )
      System.Console.WriteLine( "    size2 = 15" )
      System.Console.WriteLine( "    mean1 = 165" )
      System.Console.WriteLine( "    mean2 = 168" )
      System.Console.WriteLine( "    standardDeviation1 = 3" )
      System.Console.WriteLine( "    standardDeviation2 = 3.4" )
      System.Console.WriteLine( "    significanceLevel = 95" )
      ' Here we evaluate the confidence interval for  the  difference  between
      ' means.
      Dim difference2means1 As Double() = instanceOfStudentConfidence.MeansDifference( _
         20, _
         15, _
         165.0, _
         168.0, _
         3.0, _
         3.4, _
         95.0 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The 95 percent confidence interval is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( difference2means1, ", " ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the bounds  of  the  Upper  and  Lower  one-sided  confidence +" )
      System.Console.WriteLine( "+ intervals of the Mean                                                  +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    sideMean( int sampleSize," )
      System.Console.WriteLine( "              double mean," )
      System.Console.WriteLine( "              double standardDeviation," )
      System.Console.WriteLine( "              double significanceLevel )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the bounds  of  the  upper  and  lower  90  percent" )
      System.Console.WriteLine( "     one-sided confidence interval of a sample group of  15  people  with" )
      System.Console.WriteLine( "     an average height of 165cm, and a standard deviation of the  heights" )
      System.Console.WriteLine( "     of 10cm." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    sampleSize = 15" )
      System.Console.WriteLine( "    mean = 165" )
      System.Console.WriteLine( "    standardDeviation = 10" )
      System.Console.WriteLine( "    significanceLevel = 90" )
      ' Here we evaluate the upper and lower one-sided confidence interval  of
      ' the mean.
      Dim sideMean1 As Double() = instanceOfStudentConfidence.SideMean( _
         15, _
         165.0, _
         10.0, _
         90.0 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The array of length two where the first term corresponds to the  lower" )
      System.Console.WriteLine( "    bound of the upper one-sided confidence interval and the  second  term" )
      System.Console.WriteLine( "    corresponds to the upper  bound  of  the  lower  one-sided  confidence" )
      System.Console.WriteLine( "    interval is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( sideMean1, ", " ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the bound of the Upper one-sided confidence interval  of  the +" )
      System.Console.WriteLine( "+ Mean                                                                   +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    sideMeanUp( int sampleSize," )
      System.Console.WriteLine( "                double mean," )
      System.Console.WriteLine( "                double standardDeviation," )
      System.Console.WriteLine( "                double significanceLevel )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the  bounds  of  the  90  percent  Upper  one-sided" )
      System.Console.WriteLine( "     confidence interval of a sample group of 15 people with  an  average" )
      System.Console.WriteLine( "     height of 165cm, and a standard deviation of the heights of 10cm." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    sampleSize = 15" )
      System.Console.WriteLine( "    mean = 165" )
      System.Console.WriteLine( "    standardDeviation = 10" )
      System.Console.WriteLine( "    significanceLevel = 90" )
      ' Here we evaluate the (lower) bound of the Upper  one-sided  confidence
      ' interval.
      Dim sideMeanUp1 As Double = instanceOfStudentConfidence.SideMeanUp( _
         15, _
         165.0, _
         10.0, _
         90.0 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The lower bound of the Upper one-sided confidence interval is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * sideMeanUp1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the bound of the Lower one-sided confidence interval  of  the +" )
      System.Console.WriteLine( "+ Mean                                                                   +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    sideMeanDown( int sampleSize," )
      System.Console.WriteLine( "                  double mean," )
      System.Console.WriteLine( "                  double standardDeviation," )
      System.Console.WriteLine( "                  double significanceLevel )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the  bounds  of  the  90  percent  Lower  one-sided" )
      System.Console.WriteLine( "     confidence interval of a sample group of 15 people with  an  average" )
      System.Console.WriteLine( "     height of 165cm, and a standard deviation of the heights of 10cm." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    sampleSize = 15" )
      System.Console.WriteLine( "    mean = 165" )
      System.Console.WriteLine( "    standardDeviation = 10" )
      System.Console.WriteLine( "    significanceLevel = 90" )
      ' Here we evaluate the (upper) bound of the Lower  one-sided  confidence
      ' interval.
      Dim sideMeanDown1 As Double = instanceOfStudentConfidence.SideMeanDown( _
         15, _
         165.0, _
         10.0, _
         90.0 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The (upper) bound of the Lower one-sided confidence interval is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * sideMeanDown1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( " " )
   End Sub
End Module

