Imports System
Imports WebCab.Lib.Util.Example
Imports WebCab.Libraries.Statistics.PDistributions

Module StandardNormalProbabilityDistributionClient
   Sub Main()
      ' used components
      Dim instanceOfStandardNormalProbabilityDistribution As WebCab.Libraries.Statistics.PDistributions.StandardNormalProbabilityDistribution = New WebCab.Libraries.Statistics.PDistributions.StandardNormalProbabilityDistribution
      '
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "         ################################################################" )
      System.Console.WriteLine( "         # StandardNormalProbabilityDistribution Console Client Example #" )
      System.Console.WriteLine( "         ################################################################" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " Overview" )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    With the client example we illustrate the  application  of  each  of" )
      System.Console.WriteLine( "    the                                   method  contained  within  the" )
      System.Console.WriteLine( "    StandardNormalProbabilityDistribution class." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the Probability on an interval +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability( double lowerBound," )
      System.Console.WriteLine( "                 double upperBound )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the Standard Normal probability between -1  and  1," )
      System.Console.WriteLine( "     that is, one standard deviation shift above and below the mean." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    lowerBound = -1" )
      System.Console.WriteLine( "    upperBound = 1" )
      ' Here we evaluate the Standard Normal probability  between  -1  and  1,
      ' that is, one standard deviation shift above and below the mean.
      Dim prob1 As Double = instanceOfStandardNormalProbabilityDistribution.Probability( _
         -1.0, _
         1.0 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The probability is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * prob1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the Probability below a point +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probabilityDown( double upperBound )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the Standard Normal  probability  below  the  point" )
      System.Console.WriteLine( "     0.5." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    upperBound = 0.5" )
      ' Here we evaluate the probability of the below the point 1.
      Dim probDown1 As Double = instanceOfStandardNormalProbabilityDistribution.ProbabilityDown( _
         0.5 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The probability is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * probDown1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the Probability above a point +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probabilityUp( double lowerBound )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the Standard Normal  probability  above  the  point" )
      System.Console.WriteLine( "     0.5." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    lowerBound = 0.5" )
      ' Here we evaluate the probability above the point 0.5.
      Dim probUp1 As Double = instanceOfStandardNormalProbabilityDistribution.ProbabilityUp( _
         0.5 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The probability is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * probUp1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Estimate the Probability on an interval +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probabilityEstimation( double lowerBound," )
      System.Console.WriteLine( "                           double upperBound )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here    we  estimate  the  Standard  Normal  probability  using  the" )
      System.Console.WriteLine( "     cumulative normal probability distribution between -1  and  1,  that" )
      System.Console.WriteLine( "     is, one standard deviation shift above and below the mean." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    lowerBound = -1" )
      System.Console.WriteLine( "    upperBound = 1" )
      ' Here we estimate the Standard Normal probability  between  -1  and  1,
      ' that is, one standard deviation shift above and below the mean.
      Dim probEst1 As Double = instanceOfStandardNormalProbabilityDistribution.ProbabilityEstimation( _
         -1.0, _
         1.0 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The probability is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * probEst1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Estimate the Probability below a point +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probabilityDownEstimation( double upperBound )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here    we  estimate  the  Standard  Normal  probability  using  the" )
      System.Console.WriteLine( "     cumulative normal probability distribution below the point 0.5." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    upperBound = 0.5" )
      ' Here we evaluate the probability of the below the point 1.
      Dim probDownEst1 As Double = instanceOfStandardNormalProbabilityDistribution.ProbabilityDownEstimation( _
         0.5 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The probability is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * probDownEst1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Estimate the Probability above a point +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probabilityUpEstimation( double lowerBound )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here    we  estimate  the  Standard  Normal  probability  using  the" )
      System.Console.WriteLine( "     cumulative normal probability distribution above the point 0.5." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    lowerBound = 0.5" )
      ' Here we estimate the probability above the point 0.5.
      Dim probUpEst1 As Double = instanceOfStandardNormalProbabilityDistribution.ProbabilityUpEstimation( _
         0.5 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The probability is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * probUpEst1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the Density Function +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    densityFunction( double evaluationPoint )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the probability density function at the point 0.5." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    evaluationPoint = 0.5" )
      ' Here we evaluate the probability density function at the point 0.5.
      Dim density1 As Double = instanceOfStandardNormalProbabilityDistribution.DensityFunction( _
         0.5 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The value of the probability density function is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * density1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++" )
      System.Console.WriteLine( "+ Get the Mean +" )
      System.Console.WriteLine( "++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    getMean(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here      we  get  the  mean  of  the  Standard  Normal  Probability" )
      System.Console.WriteLine( "     Distribution." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' Here we get the mean.
      Dim mean1 As Double = instanceOfStandardNormalProbabilityDistribution.GetMean( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The mean is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * mean1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++" )
      System.Console.WriteLine( "+ Get the Variance +" )
      System.Console.WriteLine( "++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    getVariance(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here  we  get  the  variance  of  the  Standard  Normal  Probability" )
      System.Console.WriteLine( "     Distribution." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' Here we get the variance.
      Dim variance1 As Double = instanceOfStandardNormalProbabilityDistribution.GetVariance( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The variance is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * variance1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Convert to Standard Normal Distribution +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    convertToSND( double mean," )
      System.Console.WriteLine( "                  double variance," )
      System.Console.WriteLine( "                  double randomVariable )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we convert the value of  the  normal  probability  distribution" )
      System.Console.WriteLine( "     with    mean  2,  and  variance  1.2,  at  the  point  2.3,  to  the" )
      System.Console.WriteLine( "     corresponding          value  of  the  standard  normal  probability" )
      System.Console.WriteLine( "     distribution." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    mean = 2" )
      System.Console.WriteLine( "    variance = 1.2" )
      System.Console.WriteLine( "    randomVariable = 2.3" )
      ' Here we convert to the value of the normal distribution  for  a  given
      ' value of the random variable.
      Dim convert1 As Double = instanceOfStandardNormalProbabilityDistribution.ConvertToSND( _
         2.0, _
         1.2, _
         2.3 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The value of the Standard Normal Probability distribution is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * convert1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the Inverse +" )
      System.Console.WriteLine( "++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    inverse( double probability )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the inverse  of  the  Standard  Normal  Probability" )
      System.Console.WriteLine( "     Distribution when the values of  the  probability  is  0.25  (or  25" )
      System.Console.WriteLine( "     percent)." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability = 0.25" )
      ' Evaluates the inverse of the Standard Normal Probability  Distribution
      ' when the value of the probability is 0.25 (or 25 percent).
      Dim inverse1 As Double = instanceOfStandardNormalProbabilityDistribution.Inverse( _
         0.25 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The value of the Inverse of the Standard Probability Distribution is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * inverse1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the Inverse to a given accuracy and maximum number of steps +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    inverse( double probability," )
      System.Console.WriteLine( "             double accuracy," )
      System.Console.WriteLine( "             int maximumSteps )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we evaluate the inverse  of  the  Standard  Normal  Probability" )
      System.Console.WriteLine( "     Distribution when the values of  the  probability  is  0.25  (or  25" )
      System.Console.WriteLine( "     percent). The results will be  returned  when  the  value  has  been" )
      System.Console.WriteLine( "     found to within 0.01, if the maximum number of iterations of 50  has" )
      System.Console.WriteLine( "     been reached." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability = 0.25" )
      System.Console.WriteLine( "    accuracy = 0.01" )
      System.Console.WriteLine( "    maximumSteps = 50" )
      ' Evaluates the inverse of the Standard Normal Probability  Distribution
      ' when the value of the probability is 0.25 (or 25 percent) to 0.01.
      Dim inverseAcc1 As Double = instanceOfStandardNormalProbabilityDistribution.Inverse( _
         0.25, _
         0.01, _
         50 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The value of the Inverse of the Standard Probability Distribution is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * inverseAcc1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Evaluate the `Inverse about Mean' +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    inverseAroundMean( double probability )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we solve the inverse problem about the mean  for  the  Standard" )
      System.Console.WriteLine( "     Normal Probability Distribution when the probability is 0.25 (or  25" )
      System.Console.WriteLine( "     percent)." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    probability = 0.25" )
      ' Here we solve the inverse problem about  the  mean  for  the  Standard
      ' Normal Probability Distribution when the porbability is  0.25  (or  25
      ' percent).
      Dim inverseAroundMean1 As Double = instanceOfStandardNormalProbabilityDistribution.InverseAroundMean( _
         0.25 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The value of x required such  that  probability  distribution  on  the" )
      System.Console.WriteLine( "    interval [mean - x, mean + x], is 0.25 is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * inverseAroundMean1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Generate the Random Number +" )
      System.Console.WriteLine( "++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    getRandomValue(  )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here    we  generate  a  Random  Number  from  the  Standard  Normal" )
      System.Console.WriteLine( "     Probability Distribution." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      ' Here we generate a Random Number from the Standard Normal  Probability
      ' Distribnution.
      Dim random1 As Double = instanceOfStandardNormalProbabilityDistribution.GetRandomValue( _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The Random number generated is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( CType( 10000 * random1, Integer ) / 10000.0 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Generate a set of Random Values +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    getRandomValues( int numberOfRandomValues )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we generate a set  of  5,  Random  Numbers  from  the  Standard" )
      System.Console.WriteLine( "     Normal Probability Distribution." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    numberOfRandomValues = 5" )
      ' Here we generate a set of 5, Random Numbers from the  Standard  Normal
      ' Probability Distribution.
      Dim getRandomValues1 As Double() = instanceOfStandardNormalProbabilityDistribution.GetRandomValues( _
         5 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The set of 5 Random Number generated was:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( getRandomValues1, ", " ) )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( " " )
   End Sub
End Module

