using System;


public class NormalProbabilityDistributionClient {
	public static void Main () {
		try {
			NormalProbabilityDistribution proxy = new NormalProbabilityDistribution ();
			proxy.CookieContainer = new System.Net.CookieContainer ();
			
			Console.WriteLine ("SetMean (10)");
			proxy.SetMean (10);
			Console.WriteLine ("SetVariance (2)");
			proxy.SetVariance (2);
			
			Console.WriteLine ("GetMean (): " + proxy.GetMean ());
			Console.WriteLine ("GetVariance (): " + proxy.GetVariance ());
			Console.WriteLine ("ProbabilityDown(0): " + proxy.ProbabilityDown(0));
			Console.WriteLine ("Inverse (0.95): " + proxy.Inverse (0.95));
			Console.WriteLine ("ProbabilityDown (Inverse(0.95)): " + proxy.ProbabilityDown (proxy.Inverse(0.95)));
			Console.WriteLine ("Probability (0.2, 0.3): " + proxy.Probability (0.2, 0.3));
			Console.WriteLine ("Inverse(0.20): " + proxy.Inverse(0.20));
			Console.WriteLine ("GetRandomValue(): " + proxy.GetRandomValue());			

			proxy = null;
		}
		catch (Exception e) {
			Console.WriteLine (e);
		}
	}
}