using System;
using WebCab.Lib.Util.Example;

public class CorrelationClient {
   public static void Main( String[] args ) {
      // used components
      Correlation instanceOfCorrelation = new Correlation();
      //
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "                      ######################################" );
      System.Console.WriteLine( "                      # Correlation Console Client Example #" );
      System.Console.WriteLine( "                      ######################################" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " Overview" );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Within this client example we show how the  (stateless)  Correlation" );
      System.Console.WriteLine( "    Component can be used to  analyze  the  regression  and  correlation" );
      System.Console.WriteLine( "    properties of a given set." );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    TV Advertising Campaign" );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    Here the sample data consists of the number of TV commercials  shown" );
      System.Console.WriteLine( "    for a store  over  10  weeks  and  the  corresponding  sales  volume" );
      System.Console.WriteLine( "    ($100s) achieved by the store, was as follows:" );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "       - Week 1: Number of TV Commercials 2, Sales Volume 50" );
      System.Console.WriteLine( "       - Week 2: Number of TV Commercials 5, Sales Volume 57" );
      System.Console.WriteLine( "       - Week 3: Number of TV Commercials 1, Sales Volume 41" );
      System.Console.WriteLine( "       - Week 4: Number of TV Commercials 3, Sales Volume 54" );
      System.Console.WriteLine( "       - Week 5: Number of TV Commercials 4, Sales Volume 54" );
      System.Console.WriteLine( "       - Week 6: Number of TV Commercials 1, Sales Volume 38" );
      System.Console.WriteLine( "       - Week 7: Number of TV Commercials 5, Sales Volume 63" );
      System.Console.WriteLine( "       - Week 8: Number of TV Commercials 3, Sales Volume 48" );
      System.Console.WriteLine( "       - Week 9: Number of TV Commercials 4, Sales Volume 59" );
      System.Console.WriteLine( "       - Week 10: Number of TV Commercials 2, Sales Volume 46" );
      System.Console.WriteLine( "       " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    We will proceed by first setting  the  data  set  to  be  considered" );
      System.Console.WriteLine( "    through out the example and then evaluate a  number  of  qualitative" );
      System.Console.WriteLine( "    properties of this data set using the methods contained within  this" );
      System.Console.WriteLine( "    component." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate Pearson's Correlation Coefficient +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    pearsonCorrelationCoefficient( double[] xValues," );
      System.Console.WriteLine( "                                   double[] yValues )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate Pearson's Correlation Coefficient of the  data  set" );
      System.Console.WriteLine( "     corresponding to the TV Commercial  advertising  campaign  described" );
      System.Console.WriteLine( "     within the overview." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValues = {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}" );
      System.Console.WriteLine( "    yValues = {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}" );
      // Here we evaluate Pearson's Correlation Coefficient  of  the  data  set
      // corresponding to the TV commercial advertising campaign  described  in
      // the overview.
      double pearsons1 = instanceOfCorrelation.PearsonCorrelationCoefficient( 
         new double[] {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}, // xValues
         new double[] {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0} // yValues
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Pearson's Correlation Coefficient is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * pearsons1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate Spearson's Rank Correlation Coefficient +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    spearmanRankTest( double[] xValues," );
      System.Console.WriteLine( "                      double[] yValues )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate Spearman's Correlation Coefficient of the data  set" );
      System.Console.WriteLine( "     corresponding to the TV Commercial  advertising  campaign  described" );
      System.Console.WriteLine( "     within the overview." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValues = {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}" );
      System.Console.WriteLine( "    yValues = {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}" );
      // Here we evaluate Spearman's Correlation Coefficient of  the  data  set
      // corresponding to the TV commercial advertising campaign  described  in
      // the overview.
      double spearmans1 = instanceOfCorrelation.SpearmanRankTest( 
         new double[] {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}, // xValues
         new double[] {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0} // yValues
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Spearman's Correlation Coefficient is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * spearmans1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluates Kendall's Correlation Coefficient +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    kendallCorrelationCoefficient( double[] xValues," );
      System.Console.WriteLine( "                                   double[] yValues )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate Kendall's Correlation coefficient for the data  set" );
      System.Console.WriteLine( "     corresponding to the TV Commercial  advertising  campaign  described" );
      System.Console.WriteLine( "     within the overview." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValues = {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}" );
      System.Console.WriteLine( "    yValues = {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}" );
      // Here we evaluate Kendall's correlation coefficient  of  the  data  set
      // corresponding to the TV commercial advertising campaign  described  in
      // the overview.
      double kendalls1 = instanceOfCorrelation.KendallCorrelationCoefficient( 
         new double[] {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}, // xValues
         new double[] {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0} // yValues
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Kendall's Correlation Coefficient is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * kendalls1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Significance test for Pearson's Correlation Coefficient +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    significance( double[] xValues," );
      System.Console.WriteLine( "                  double[] yValues," );
      System.Console.WriteLine( "                  double correlationCoefficient )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the value of the significance test of the correlation  found" );
      System.Console.WriteLine( "     according      to  Pearson's  Correlation  Coefficient  for  the  TV" );
      System.Console.WriteLine( "     Commercial advertising campaign described within the overview?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValues = {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}" );
      System.Console.WriteLine( "    yValues = {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}" );
      System.Console.WriteLine( "    correlationCoefficient = pearson2" );
      // Here we evaluate Pearson's Correlation Coefficient  of  the  data  set
      // corresponding to the TV commercial advertising campaign  described  in
      // the overview.
      double pearson2 = instanceOfCorrelation.PearsonCorrelationCoefficient( 
         new double[] {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}, // xValues
         new double[] {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0} // yValues
      );
      // Here    we  evaluate  the  significance  of  the  value  of  Pearson's
      // Correlation Coefficient for the  data  set  corresponding  to  the  TV
      // commercial advertising campaign described in the overview.
      double significance1 = instanceOfCorrelation.Significance( 
         new double[] {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}, // xValues
         new double[] {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}, // yValues
         pearson2 // correlationCoefficient
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the significance test is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * significance1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Mean of the Weekly Number of Commercials +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    mean( double[] values )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the arithmetic mean of the first elements in the pairs  from" );
      System.Console.WriteLine( "     which the data set is constructed from?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    values = {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}" );
      // Evaluates the mean of the  first  elements  in  the  pairs  (i.e.  the
      // weekly number of TV commercials) in a given week from which  the  data
      // set  corresponding  to  the  TV  commercial  advertising  campaign  as
      // described in the overview.
      double meanOfFirst1 = instanceOfCorrelation.Mean( 
         new double[] {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0} // values
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The arithmetic mean of the first elements of the pairs is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * meanOfFirst1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Mean of the Weekly Sales Volume +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    mean( double[] values )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the arithmetic mean of the weekly sales  volume  of  the  TV" );
      System.Console.WriteLine( "     commercial advertising campaign described within the overview?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    values = {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}" );
      // Evaluates the mean of the second  elements  in  the  pairs  (i.e.  the
      // weekly sales volume) from which the data set corresponding to  the  TV
      // commercial advertising campaign described in the overview.
      double meanOfSecond1 = instanceOfCorrelation.Mean( 
         new double[] {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0} // values
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The arithmetic mean of the second elements of the pairs is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * meanOfSecond1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Variance of the Weekly Number of Commercials +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    sampleVariance( double[] values )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the variance of the  sales  volume  resulting  from  the  TV" );
      System.Console.WriteLine( "     commercial advertising campaign described within the overview?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    values = {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}" );
      // Evaluates the variance of the weekly number of commercials from  which
      // the data set corresponding to the TV commercial  advertising  campaign
      // described in the overview.
      double varianceOfFirst1 = instanceOfCorrelation.SampleVariance( 
         new double[] {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0} // values
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The variance of the sales volume is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * varianceOfFirst1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Variance of the Weekly Sales Volume +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    sampleVariance( double[] values )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What  is  the  variance  of  the  weekly  sales  volume  of  the  TV" );
      System.Console.WriteLine( "     commercial advertising campaign described within the overview?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    values = {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}" );
      // Evaluates   the  variance  of  the  weekly  sales  volume  of  the  TV
      // commercial advertising campaign described in the overview.
      double varianceOfSecond1 = instanceOfCorrelation.SampleVariance( 
         new double[] {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0} // values
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The variance of the second elements of the pairs is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * varianceOfSecond1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Construction of the Regression Line of Y on X +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    leastSquaresRegressionLineY( double[] xValues," );
      System.Console.WriteLine( "                                 double[] yValues )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Construct  the  regression  line  of  Y  on  X,  for  the  data  set" );
      System.Console.WriteLine( "     corresponding to the TV commercial  advertising  campaign  described" );
      System.Console.WriteLine( "     within the overview?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValues = {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}" );
      System.Console.WriteLine( "    yValues = {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}" );
      // Here we construct the regression line of Y on X.
      double[] regressionX1 = instanceOfCorrelation.LeastSquaresRegressionLineY( 
         new double[] {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}, // xValues
         new double[] {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0} // yValues
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The first and second coefficients  of  the  regression  line,  Y(y)  =" );
      System.Console.WriteLine( "    d[0]*X+d[1]; for the data set considered are:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( regressionX1, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Estimate the Sales for a given Number of Commercials +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    estimateY( double[] xValues," );
      System.Console.WriteLine( "               double[] yValues," );
      System.Console.WriteLine( "               double estPoint )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Assuming that the number of sales have a  linear  relationship  with" );
      System.Console.WriteLine( "     the number of of commercials, then the estimate for  the  number  of" );
      System.Console.WriteLine( "     sales when the number of commercials is 6, in  accordance  with  the" );
      System.Console.WriteLine( "     linear regression line is?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValues = {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}" );
      System.Console.WriteLine( "    yValues = {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}" );
      System.Console.WriteLine( "    estPoint = 6" );
      // Here we estimate the number of sales when the  number  of  commercials
      // is 6.
      double estimateSales1 = instanceOfCorrelation.EstimateY( 
         new double[] {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}, // xValues
         new double[] {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}, // yValues
         6.0 // estPoint
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The estimate number of sales is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * estimateSales1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Construction of the Regression Line of X on Y +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    leastSquaresRegressionLineX( double[] xValues," );
      System.Console.WriteLine( "                                 double[] yValues )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Construct  the  regression  line  of  X  on  Y,  for  the  data  set" );
      System.Console.WriteLine( "     corresponding to the TV commercial  advertising  campaign  described" );
      System.Console.WriteLine( "     within the overview?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValues = {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}" );
      System.Console.WriteLine( "    yValues = {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}" );
      // Here we construct the regression line of X on Y.
      double[] regressionY1 = instanceOfCorrelation.LeastSquaresRegressionLineX( 
         new double[] {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}, // xValues
         new double[] {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0} // yValues
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The first and second coefficients  of  the  regression  line,  X(x)  =" );
      System.Console.WriteLine( "    d[0]*Y+d[1]; for the data set considered are:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( regressionY1, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Estimate the Sales for a given Number of Commercials +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    estimateX( double[] xValues," );
      System.Console.WriteLine( "               double[] yValues," );
      System.Console.WriteLine( "               double estPoint )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we estimate the number of commercials  necessary  in  order  to" );
      System.Console.WriteLine( "     generate sales of 60 ($100)?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValues = {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}" );
      System.Console.WriteLine( "    yValues = {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}" );
      System.Console.WriteLine( "    estPoint = 60" );
      // Here we estimate the total sales for a given number of commercials.
      double estimateCommercials1 = instanceOfCorrelation.EstimateX( 
         new double[] {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}, // xValues
         new double[] {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}, // yValues
         60.0 // estPoint
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The estimated number of commercials necessary is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * estimateCommercials1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Coefficient of Determination +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    coefficientOfDetermination( double[] xValues," );
      System.Console.WriteLine( "                                double[] yValues )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What     is  the  coefficient  of  determination  of  the  data  set" );
      System.Console.WriteLine( "     corresponding to the TV commercial  advertising  campaign  described" );
      System.Console.WriteLine( "     within the overview?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValues = {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}" );
      System.Console.WriteLine( "    yValues = {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}" );
      // Here we evaluate the coefficient of  determination  of  the  data  set
      // considered.
      double coeffOfDetermination1 = instanceOfCorrelation.CoefficientOfDetermination( 
         new double[] {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}, // xValues
         new double[] {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0} // yValues
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The coefficient of determination of the data set considered is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * coeffOfDetermination1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Residuals of pairs from the data set considered +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    residuals( double[] xValues," );
      System.Console.WriteLine( "               double[] yValues," );
      System.Console.WriteLine( "               int index )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the residual of the 1st pair of  elements  within  the  data" );
      System.Console.WriteLine( "     set    corresponding  to  the  TV  commercial  advertising  campaign" );
      System.Console.WriteLine( "     described within the overview?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValues = {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}" );
      System.Console.WriteLine( "    yValues = {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}" );
      System.Console.WriteLine( "    index = 0" );
      // Here we evaluate the residual of the 1st pair.
      double residuals1 = instanceOfCorrelation.Residuals( 
         new double[] {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}, // xValues
         new double[] {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}, // yValues
         0 // index
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The residual  of  the  1st  pair  of  elements  within  the  data  set" );
      System.Console.WriteLine( "    corresponding to the TV commercial advertising campaign  described  in" );
      System.Console.WriteLine( "    the overview is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * residuals1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Average the residuals +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    residualsAverage( double[] xValues," );
      System.Console.WriteLine( "                      double[] yValues )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the arithmetic average of all the residuals of the data  set" );
      System.Console.WriteLine( "     corresponding to the TV commercial  advertising  campaign  described" );
      System.Console.WriteLine( "     in the overview?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValues = {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}" );
      System.Console.WriteLine( "    yValues = {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}" );
      // Here we evaluate the average of all the  residuals  of  the  data  set
      // corresponding to  the  TV  commercial  advertising  campaign  describe
      // within the overview.
      double averageResiduals1 = instanceOfCorrelation.ResidualsAverage( 
         new double[] {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}, // xValues
         new double[] {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0} // yValues
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The arithmetic average of the residuals of the data set is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * averageResiduals1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( " " );
   }
}
