using System;
using WebCab.Lib.Util.Example;

public class StudentClient {
   public static void Main( String[] args ) {
      // used components
      Correlation instanceOfCorrelation = new Correlation();
      //
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "                        ##################################" );
      System.Console.WriteLine( "                        # Student Console Client Example #" );
      System.Console.WriteLine( "                        ##################################" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " Overview" );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Within this Client we study the relationship the results found  from" );
      System.Console.WriteLine( "    two examinations using the Stateless version the Correlation  class." );
      System.Console.WriteLine( "    In particular, for the results considered we will evaluate:" );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "       - Pearson's Correlation Coefficient" );
      System.Console.WriteLine( "       - Significance Test for Pearson's Correlation Coefficient" );
      System.Console.WriteLine( "       - Spearman's Rank Correlation Coefficient" );
      System.Console.WriteLine( "       - Significance Test for Spearman's Rank Correlation Coefficient" );
      System.Console.WriteLine( "       - Kendall's Correlation Coefficient" );
      System.Console.WriteLine( "       " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    Let's consider the relationship between the grades of 7 students  on" );
      System.Console.WriteLine( "    successive examinations." );
      System.Console.WriteLine( "    Let Xi and Yi denote the scores earned by Student i (i = 1, ...,  7)" );
      System.Console.WriteLine( "    on the first and second examinations in the programming  class.  The" );
      System.Console.WriteLine( "    numbers, which are given in the table below, have been  scaled  down" );
      System.Console.WriteLine( "    to make the computations simpler; as the scores are  presented,  the" );
      System.Console.WriteLine( "    highest possible grade was 15 on each of the two examinations." );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "       - Student 1: Score in 1st Exam(Xi) 70: Score in 2nd Exam (Yi) 64" );
      System.Console.WriteLine( "       - Student 2: Score in 1st Exam(Xi) 78: Score in 2nd Exam (Yi) 82" );
      System.Console.WriteLine( "       - Student 3: Score in 1st Exam(Xi) 62: Score in 2nd Exam (Yi) 55" );
      System.Console.WriteLine( "       - Student 4: Score in 1st Exam(Xi) 46: Score in 2nd Exam (Yi) 55" );
      System.Console.WriteLine( "       - Student 5: Score in 1st Exam(Xi) 87: Score in 2nd Exam (Yi) 95" );
      System.Console.WriteLine( "       - Student 6: Score in 1st Exam(Xi) 60: Score in 2nd Exam (Yi) 67" );
      System.Console.WriteLine( "       - Student 7: Score in 1st Exam(Xi) 57: Score in 2nd Exam (Yi) 52" );
      System.Console.WriteLine( "       " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    We investigate to what degree for each student  the  results  within" );
      System.Console.WriteLine( "    the two exams are correlated by applying a number of the  techniques" );
      System.Console.WriteLine( "    offered by the Correlation class." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluation of the Pearson's Correlation Coefficient +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    pearsonCorrelationCoefficient( double[] xValues," );
      System.Console.WriteLine( "                                   double[] yValues )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the Pearson's Correlation Coefficient  between  the" );
      System.Console.WriteLine( "     two exams for the Students  results.  Note,  that  this  coefficient" );
      System.Console.WriteLine( "     will lie within the  range  [-1,1],  where  -1  indicates  that  the" );
      System.Console.WriteLine( "     results in perfectly negatively correlated and 1 indicates that  the" );
      System.Console.WriteLine( "     results are perfectly correlated." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValues = {70.0, 78.0, 62.0, 46.0, 87.0, 60.0, 57.0}" );
      System.Console.WriteLine( "    yValues = {64.0, 82.0, 55.0, 55.0, 95.0, 67.0, 52.0}" );
      // Here we evaluate Pearson's Correlation  Coefficient  for  the  results
      // obtained.
      double pearson1 = instanceOfCorrelation.PearsonCorrelationCoefficient( 
         new double[] {70.0, 78.0, 62.0, 46.0, 87.0, 60.0, 57.0}, // xValues
         new double[] {64.0, 82.0, 55.0, 55.0, 95.0, 67.0, 52.0} // yValues
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The Pearson's Correlation Coefficient between the two  exams  set  for" );
      System.Console.WriteLine( "    the set of students is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * pearson1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate the Significance Test for Pearson's +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    significance( double[] xValues," );
      System.Console.WriteLine( "                  double[] yValues," );
      System.Console.WriteLine( "                  double correlationCoefficient )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate  the  Significance  test  for  the  result  of  the" );
      System.Console.WriteLine( "     Pearson's Correlation Coefficient evaluated above." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValues = {70.0, 78.0, 62.0, 46.0, 87.0, 60.0, 57.0}" );
      System.Console.WriteLine( "    yValues = {64.0, 82.0, 55.0, 55.0, 95.0, 67.0, 52.0}" );
      System.Console.WriteLine( "    correlationCoefficient = pearson1" );
      // Here we  evaluate  the  significance  test  of  the  result  found  by
      // Pearson's Correlation Coefficient.
      double sig1 = instanceOfCorrelation.Significance( 
         new double[] {70.0, 78.0, 62.0, 46.0, 87.0, 60.0, 57.0}, // xValues
         new double[] {64.0, 82.0, 55.0, 55.0, 95.0, 67.0, 52.0}, // yValues
         pearson1 // correlationCoefficient
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The significant test for the result  found  by  Pearson's  Correlation" );
      System.Console.WriteLine( "    Coefficient is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * sig1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluation of the Spearman's Rank Correlation Coefficient +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    spearmanRankTest( double[] xValues," );
      System.Console.WriteLine( "                      double[] yValues )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here   we  evaluate  the  Spearman's  Rank  Correlation  Coefficient" );
      System.Console.WriteLine( "     between the two exams for the students results." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValues = {70.0, 78.0, 62.0, 46.0, 87.0, 60.0, 57.0}" );
      System.Console.WriteLine( "    yValues = {64.0, 82.0, 55.0, 55.0, 95.0, 67.0, 52.0}" );
      // Here we evaluate  Spearman's  Rank  Correlation  Coefficient  for  the
      // students results.
      double rank1 = instanceOfCorrelation.SpearmanRankTest( 
         new double[] {70.0, 78.0, 62.0, 46.0, 87.0, 60.0, 57.0}, // xValues
         new double[] {64.0, 82.0, 55.0, 55.0, 95.0, 67.0, 52.0} // yValues
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the Spearman's Rank Correlation Coefficient is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * rank1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate   the  Significance  Test  for  Spearman's  Rank  Correlation +" );
      System.Console.WriteLine( "+ Coefficient                                                            +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    significance( double[] xValues," );
      System.Console.WriteLine( "                  double[] yValues," );
      System.Console.WriteLine( "                  double correlationCoefficient )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate  the  Significance  test  for  the  result  of  the" );
      System.Console.WriteLine( "     Spearman's Rank Correlation Coefficient evaluated above." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValues = {70.0, 78.0, 62.0, 46.0, 87.0, 60.0, 57.0}" );
      System.Console.WriteLine( "    yValues = {64.0, 82.0, 55.0, 55.0, 95.0, 67.0, 52.0}" );
      System.Console.WriteLine( "    correlationCoefficient = rank1" );
      // Here we  evaluate  the  significance  test  of  the  result  found  by
      // Spearman's Rank Correlation Coefficient.
      double sig2 = instanceOfCorrelation.Significance( 
         new double[] {70.0, 78.0, 62.0, 46.0, 87.0, 60.0, 57.0}, // xValues
         new double[] {64.0, 82.0, 55.0, 55.0, 95.0, 67.0, 52.0}, // yValues
         rank1 // correlationCoefficient
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The   significant  test  for  the  result  found  by  Spearman's  Rank" );
      System.Console.WriteLine( "    Correlation Coefficient is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * sig2 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Kendall's Correlation Coefficient +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    kendallCorrelationCoefficient( double[] xValues," );
      System.Console.WriteLine( "                                   double[] yValues )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate Kendall's Correlation Coefficient between  the  two" );
      System.Console.WriteLine( "     exams for the students results." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValues = {70.0, 78.0, 62.0, 46.0, 87.0, 60.0, 57.0}" );
      System.Console.WriteLine( "    yValues = {64.0, 82.0, 55.0, 55.0, 95.0, 67.0, 52.0}" );
      // Here we evaluate Kendall's Correlation  Coefficient  for  the  Student
      // exam results.
      double ken1 = instanceOfCorrelation.KendallCorrelationCoefficient( 
         new double[] {70.0, 78.0, 62.0, 46.0, 87.0, 60.0, 57.0}, // xValues
         new double[] {64.0, 82.0, 55.0, 55.0, 95.0, 67.0, 52.0} // yValues
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Kendall's Correlation Coefficient between the two exams for the  above" );
      System.Console.WriteLine( "    set of student results is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * ken1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( " " );
   }
}
