using System;
using WebCab.Lib.Util.Example;

public class CorrelationStatefulClient {
   public static void Main( String[] args ) {
      // used components
      CorrelationStateful instanceOfCorrelationStateful = new CorrelationStateful();
      //
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "                  ##############################################" );
      System.Console.WriteLine( "                  # CorrelationStateful Console Client Example #" );
      System.Console.WriteLine( "                  ##############################################" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " Overview" );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Within this client example we  show  how  the  stateful  Correlation" );
      System.Console.WriteLine( "    Component can be used to  analyze  the  regression  and  correlation" );
      System.Console.WriteLine( "    properties of a given set. Here the  sample  data  consists  of  the" );
      System.Console.WriteLine( "    number of TV commercials show for a store  over  10  weeks  and  the" );
      System.Console.WriteLine( "    corresponding sales volume achieved by the store." );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    We will proceed by first setting  the  data  set  to  be  considered" );
      System.Console.WriteLine( "    throughout the example and then evaluate  a  number  of  qualitative" );
      System.Console.WriteLine( "    properties of this data set using the methods contained within  this" );
      System.Console.WriteLine( "    component." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Set the Data set one value at a time +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    addValue( double xValue," );
      System.Console.WriteLine( "              double yValue )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     Here we set the data set one value at a time. This  data  set  which" );
      System.Console.WriteLine( "     once set can be analyzed using the other methods  in  this  stateful" );
      System.Console.WriteLine( "     class." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValue = 2" );
      System.Console.WriteLine( "    yValue = 46" );
      // Set the number of commercials and sales (in $100s) in week 1
      instanceOfCorrelationStateful.AddValue( 
         2.0, // xValue
         50.0 // yValue
      );
      // Set the number of commercials and sales (in $100s) in week 2
      instanceOfCorrelationStateful.AddValue( 
         5.0, // xValue
         57.0 // yValue
      );
      // Set the number of commercials and sales (in $100s) in week 3
      instanceOfCorrelationStateful.AddValue( 
         1.0, // xValue
         41.0 // yValue
      );
      // Set the number of commercials and sales (in $100s) in week 4
      instanceOfCorrelationStateful.AddValue( 
         3.0, // xValue
         54.0 // yValue
      );
      // Set the number of commercials and sales (in $100s) in week 5
      instanceOfCorrelationStateful.AddValue( 
         4.0, // xValue
         54.0 // yValue
      );
      // Set the number of commercials and sales (in $100s) in week 6
      instanceOfCorrelationStateful.AddValue( 
         1.0, // xValue
         38.0 // yValue
      );
      // Set the number of commercials and sales (in $100s) in week 7
      instanceOfCorrelationStateful.AddValue( 
         5.0, // xValue
         63.0 // yValue
      );
      // Set the number of commercials and sales (in $100s) in week 8
      instanceOfCorrelationStateful.AddValue( 
         3.0, // xValue
         48.0 // yValue
      );
      // Set the number of commercials and sales (in $100s) in week 9
      instanceOfCorrelationStateful.AddValue( 
         4.0, // xValue
         59.0 // yValue
      );
      // Set the number of commercials and sales (in $100s) in week 10
      instanceOfCorrelationStateful.AddValue( 
         2.0, // xValue
         46.0 // yValue
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The data set which has been set is: {{ 2, 5, 1, 3, 4, 1, 5,  3,  4,2}," );
      System.Console.WriteLine( "    {50,57,41,54,54,38,63,48,59,46}}" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Set the Data set many values at a time +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    addValues( double[] xValues," );
      System.Console.WriteLine( "               double[] yValues )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     Here we set all the values of the data set at the  same  time.  This" );
      System.Console.WriteLine( "     data set once set can be analyzed using the  other  methods  in  the" );
      System.Console.WriteLine( "     stateful class." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValues = {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}" );
      System.Console.WriteLine( "    yValues = {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0}" );
      instanceOfCorrelationStateful.AddValues( 
         new double[] {2.0, 5.0, 1.0, 3.0, 4.0, 1.0, 5.0, 3.0, 4.0, 2.0}, // xValues
         new double[] {50.0, 57.0, 41.0, 54.0, 54.0, 38.0, 63.0, 48.0, 59.0, 46.0} // yValues
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The data set which has been set is: {{ 2, 5, 1, 3, 4, 1, 5,  3,  4,2}," );
      System.Console.WriteLine( "    {50,57,41,54,54,38,63,48,59,46}}" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate Pearson's Correlation Coefficient +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    pearsonCorrelationCoefficient(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     Here we evaluate Pearson's Correlation Coefficient of the  set  data" );
      System.Console.WriteLine( "     set." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we evaluate Pearson's Correlation Coefficient  of  the  data  set
      // which has been set.
      double pearsons = instanceOfCorrelationStateful.PearsonCorrelationCoefficient( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Pearson's Correlation Coefficient is the set data set is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * pearsons ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluate Spearson's Rank Correlation Coefficient +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    spearmanRankTest(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     Here we evaluate Spearman's Correlation Coefficient of the set  data" );
      System.Console.WriteLine( "     set." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we evaluate Spearman's Correlation Coefficient of  the  data  set
      // which has been set.
      double spearmans = instanceOfCorrelationStateful.SpearmanRankTest( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Spearman's Correlation Coefficient is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * spearmans ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluates Kendall's Correlation Coefficient +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    kendallCorrelationCoefficient(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     Here we evaluate Kendall's Correlation coefficient for  the  current" );
      System.Console.WriteLine( "     data set." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we evaluate Kendall's correlation coefficient  of  the  data  set
      // which has been set
      double kendalls = instanceOfCorrelationStateful.KendallCorrelationCoefficient( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Kendall's Correlation Coefficient is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * kendalls ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Significance test for Pearson's Correlation Coefficient +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    significance( double correlationCoefficient )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     What is the value of significance  test  of  the  correlation  found" );
      System.Console.WriteLine( "     according to Pearson's Correlation Coefficient for the current  data" );
      System.Console.WriteLine( "     set?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    correlationCoefficient = pearson2" );
      // Here we evaluate Pearson's Correlation Coefficient  of  the  data  set
      // which has been set.
      double pearson2 = instanceOfCorrelationStateful.PearsonCorrelationCoefficient( 
      );
      // Here    we  evaluate  the  significance  of  the  value  of  Pearson's
      // Correlation Coefficient for the current data set
      double significance1 = instanceOfCorrelationStateful.Significance( 
         pearson2 // correlationCoefficient
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the significance test is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * significance1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Mean of the First Variable +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    meanX(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     What is the arithmetic mean of the first elements in the pairs  from" );
      System.Console.WriteLine( "     which the data set is constructed from?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Evaluates the mean of the first elements in the pairs from  which  the
      // data set is constructed from
      double meanOfFirst1 = instanceOfCorrelationStateful.MeanX( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The arithmetic mean of the first elements of the pairs is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * meanOfFirst1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Mean of the Second Variable +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    meanY(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     What is the arithmetic mean of the  second  elements  in  the  pairs" );
      System.Console.WriteLine( "     from which the data set is constructed from?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Evaluates the mean of the second elements in the pairs from which  the
      // data set is constructed from
      double meanOfSecond1 = instanceOfCorrelationStateful.MeanY( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The arithmetic mean of the second elements of the pairs is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * meanOfSecond1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Variance of the First Variable +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    sampleVarianceX(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     What is the variance of the first elements in the pairs  from  which" );
      System.Console.WriteLine( "     the data set is constructed from?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Evaluates the variance of the first elements in the pairs  from  which
      // the data set is constructed from
      double varianceOfFirst1 = instanceOfCorrelationStateful.SampleVarianceX( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The variance of the first elements of the pairs is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * varianceOfFirst1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Variance of the Second Variable +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    sampleVarianceY(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     What is the variance of the second elements in the pairs from  which" );
      System.Console.WriteLine( "     the data set us constructed from?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Evaluates the variance of the second elements in the pairs from  which
      // the data set is constructed from
      double varianceOfSecond1 = instanceOfCorrelationStateful.SampleVarianceY( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The variance of the second elements of the pairs is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * varianceOfSecond1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Construction of the Regression Line of Y on X +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    leastSquaresRegressionLineY(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     Construct the regression line of Y on X, for the current data set?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we construct the regression line of Y on X.
      double[] regressionX1 = instanceOfCorrelationStateful.LeastSquaresRegressionLineY( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The first and second coefficients  of  the  regression  line,  Y(y)  =" );
      System.Console.WriteLine( "    d[0]*X+d[1]; for the current data set are:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( regressionX1, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Estimate the Sales for a given Number of Commercials +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    estimateY( double xValue )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     Assuming that the number of sales have a  linear  relationship  with" );
      System.Console.WriteLine( "     the number of of commercials, then the estimate for  the  number  of" );
      System.Console.WriteLine( "     sales when the number of commercials is 6, in  accordance  with  the" );
      System.Console.WriteLine( "     linear regression line is?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    xValue = 6" );
      // Here we estimate the number of sales when the  number  of  commercials
      // is 6.
      double estimateSales1 = instanceOfCorrelationStateful.EstimateY( 
         6.0 // xValue
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The estimate number of sales is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * estimateSales1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Construction of the Regression Line of X on Y +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    leastSquaresRegressionLineX(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     Construct the regression line of X on Y, for the current data set?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we construct the regression line of X on Y.
      double[] regressionY1 = instanceOfCorrelationStateful.LeastSquaresRegressionLineX( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The first and second coefficients  of  the  regression  line,  X(x)  =" );
      System.Console.WriteLine( "    d[0]*Y+d[1]; for the current data set are:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( regressionY1, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Estimate the Sales for a given Number of Commercials +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    estimateX( double yValue )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     Here we estimate the number of commercials  necessary  in  order  to" );
      System.Console.WriteLine( "     generate sales of 60 ($100)?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    yValue = 60" );
      // Here we estimate the total sales for a given number of commercials.
      double estimateCommercials1 = instanceOfCorrelationStateful.EstimateX( 
         60.0 // yValue
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The estimated number of commercials necessary is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * estimateCommercials1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Coefficient of Determination +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    coefficientOfDetermination(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     What is the coefficient of determination of the current data set?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we evaluate the coefficient of determination of the current  data
      // set.
      double coeffOfDetermination1 = instanceOfCorrelationStateful.CoefficientOfDetermination( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The coefficient of determination of the current data set is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * coeffOfDetermination1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Residuals of several pairs in the curent data set +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    residuals( int index )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     What is the residual of the  1st,  3rd  and  6th  pair  of  elements" );
      System.Console.WriteLine( "     within the current data set?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    index = 0" );
      // Here we evaluate the residual of the 1st pair
      double residuals1 = instanceOfCorrelationStateful.Residuals( 
         0 // index
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The residual of the 1st, 3rd and  6th  pair  of  elements  within  the" );
      System.Console.WriteLine( "    current data set is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * residuals1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Residuals of several pairs in the curent data set +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    residuals( int index )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    index = 2" );
      // Here we evaluate the residual of the 3rd pair
      double residuals2 = instanceOfCorrelationStateful.Residuals( 
         2 // index
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * residuals2 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Residuals of several pairs in the curent data set +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    residuals( int index )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    index = 5" );
      // Here we evaluate the residual of the 6th pair
      double residuals3 = instanceOfCorrelationStateful.Residuals( 
         5 // index
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * residuals3 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Average the residuals +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    residualsAverage(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "     What is the arithmetic average of all the residuals of  the  current" );
      System.Console.WriteLine( "     data set?" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we evaluate the average of all the residuals of the current  data
      // set.
      double averageResiduals1 = instanceOfCorrelationStateful.ResidualsAverage( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The arithmetic average of the residuals of the current data set is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * averageResiduals1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( " " );
   }
}
