using System;
using WebCab.Lib.Util.Example;

public class RandomVariablesClient {
   public static void Main( String[] args ) {
      // used components
      RandomVariables instanceOfRandomVariables = new RandomVariables();
      //
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "                    ##########################################" );
      System.Console.WriteLine( "                    # RandomVariables Console Client Example #" );
      System.Console.WriteLine( "                    ##########################################" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " Overview" );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Here     we  provide  examples  for  methods  contained  within  the" );
      System.Console.WriteLine( "    RandomVariable class." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Setting a Random variable to the internal table +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    addRandomVariable( double[] values," );
      System.Console.WriteLine( "                       int[] occurrences )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we set the random variables R,  to  the  internal  table  which" );
      System.Console.WriteLine( "     takes the following values: R(1) = 2, R(2) = 4, R(3) = 2, R(4) = 6." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    values = {1.0, 2.0, 3.0, 4.0}" );
      System.Console.WriteLine( "    occurrences = {2, 4, 2, 6}" );
      // Here we set a random variable to the internal table.
      instanceOfRandomVariables.AddRandomVariable( 
         new double[] {1.0, 2.0, 3.0, 4.0}, // values
         new int[] {2, 4, 2, 6} // occurrences
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The random variable has now been set to the internal table." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Insert a Random Variable +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    insertRandomVariable( int index," );
      System.Console.WriteLine( "                          double[] values," );
      System.Console.WriteLine( "                          int[] occurrences )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we insert into the internal table of Random Variables a  Random" );
      System.Console.WriteLine( "     Variable R, which takes the following values: R(1) = 2,  R(2)  =  4," );
      System.Console.WriteLine( "     R(3) = 6, R(3) = 3." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    index = 0" );
      System.Console.WriteLine( "    values = {1.0, 2.0, 3.0, 4.0}" );
      System.Console.WriteLine( "    occurrences = {2, 4, 6, 3}" );
      // Here we insert a Random Variable into  the  1st  position  within  the
      // internal table of Random variables.
      instanceOfRandomVariables.InsertRandomVariable( 
         0, // index
         new double[] {1.0, 2.0, 3.0, 4.0}, // values
         new int[] {2, 4, 6, 3} // occurrences
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The Random Variable described above has now  been  inserted  into  the" );
      System.Console.WriteLine( "    internal table." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Remove a Random Cariable from the internal table of Random Variables +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    removeRandomVariable( int index )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we first insert a Random Variable into the  internal  table  of" );
      System.Console.WriteLine( "     Random Variables and then remove the same Random Variable." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    index = 0" );
      // Here we insert a Random Variable into  the  1st  position  within  the
      // internal table of Random variables.
      instanceOfRandomVariables.InsertRandomVariable( 
         0, // index
         new double[] {1.0, 2.0, 3.0, 4.0}, // values
         new int[] {2, 4, 6, 3} // occurrences
      );
      // We now remove the Random Variables from the internal table  which  has
      // just been set.
      instanceOfRandomVariables.RemoveRandomVariable( 
         0 // index
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The Random Variable which had just been set has now been removed  from" );
      System.Console.WriteLine( "    the internal table of Random Variables." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Number of the occurances as described by Random Variable +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    getFunctionOfRandomVariable( int index )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    index = 0" );
      // Here we set a random variable to the internal table.
      instanceOfRandomVariables.InsertRandomVariable( 
         0, // index
         new double[] {1.0, 2.0, 3.0, 4.0}, // values
         new int[] {2, 4, 2, 6} // occurrences
      );
      // Here we read off the number of occurances of the experiment  described
      // by the Random Variable which has just been set.
      double[] getFunc1 = instanceOfRandomVariables.GetFunctionOfRandomVariable( 
         0 // index
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The number of occurrence of the experiment  described  by  the  Random" );
      System.Console.WriteLine( "    Variable are:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( getFunc1, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Values of the Associated Probability Distribution +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    getProbabilityOfRandomVariable( int index )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we first set the random variables  R,  to  the  first  position" );
      System.Console.WriteLine( "     within the internal table which takes the following values:  R(1)  =" );
      System.Console.WriteLine( "     2, R(2) = 4, R(3) = 2, R(4) = 6. Then we  Read  off  the  number  of" );
      System.Console.WriteLine( "     occurrences of the events  which  occurred  within  the  experiment," );
      System.Console.WriteLine( "     namely we return" );
      System.Console.WriteLine( "     Here we first set the random variables  R,  to  the  first  position" );
      System.Console.WriteLine( "     within the internal table which takes the following values:  R(1)  =" );
      System.Console.WriteLine( "     2, R(2) = 4, R(3) = 2, R(4) = 6. We then evaluate the values of  the" );
      System.Console.WriteLine( "     associated Probability Distribution of this Random Variable." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    index = 0" );
      // Here we set a random variable to the internal table.
      instanceOfRandomVariables.InsertRandomVariable( 
         0, // index
         new double[] {1.0, 2.0, 3.0, 4.0}, // values
         new int[] {2, 4, 2, 6} // occurrences
      );
      // Here       we  evaluate  the  values  of  the  associated  probability
      // distribution for the Random Variable set.
      double[] getFunc2 = instanceOfRandomVariables.GetProbabilityOfRandomVariable( 
         0 // index
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The values of the associated Random Variable are:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( getFunc2, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Probabilities of the Probability Distribution Function +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probabilityOfEvents( int[] numberOfOccurrences )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Retrieve   the  values  of  the  probabilities  of  the  probability" );
      System.Console.WriteLine( "     distribution which is  associated  with  the  1st  random  variables" );
      System.Console.WriteLine( "     which has been set." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    numberOfOccurrences = {0}" );
      // Here we set a random variable to the internal table.
      instanceOfRandomVariables.InsertRandomVariable( 
         0, // index
         new double[] {1.0, 2.0, 3.0, 4.0}, // values
         new int[] {2, 4, 2, 6} // occurrences
      );
      // Reads off the probabilities of the probability distribution which  has
      // been set.
      double[] probEvents = instanceOfRandomVariables.ProbabilityOfEvents( 
         new int[] {0} // numberOfOccurrences
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The values of the probabilities of the probability distribution are:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( probEvents, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Probability of the Probability Distribution Function via parameters +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    probabilityOfEvents( int[] numberOfOccurrences )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What   are  the  probabilities  (i.e.  values)  of  the  probability" );
      System.Console.WriteLine( "     distribution which is associated with a random variables  which  has" );
      System.Console.WriteLine( "     four possible outcomes where the number of each outcome  is:  2,  4," );
      System.Console.WriteLine( "     2, 6; respectively." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    numberOfOccurrences = {2, 4, 2, 6}" );
      // Here we  evaluate  the  probability  distribution  associated  with  a
      // random variable.
      double[] probEvents1 = instanceOfRandomVariables.ProbabilityOfEvents( 
         new int[] {2, 4, 2, 6} // numberOfOccurrences
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The probabilities of the probability distribution are:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( probEvents1, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluation of the Cumulative Distribution Function +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    cumulativeDistFunc( int index," );
      System.Console.WriteLine( "                        double evaluationPoint )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     What is the values of the cumulative distribution  function  at  the" );
      System.Console.WriteLine( "     point 3, where the probability distribution is associated  with  the" );
      System.Console.WriteLine( "     random variable R, which takes the following values: R(1) = 2,  R(2)" );
      System.Console.WriteLine( "     = 4, R(3) = 2, R(4) = 6." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    index = 0" );
      System.Console.WriteLine( "    evaluationPoint = 3" );
      // Here we set a random variable to the internal table.
      instanceOfRandomVariables.InsertRandomVariable( 
         0, // index
         new double[] {1.0, 2.0, 3.0, 4.0}, // values
         new int[] {2, 4, 2, 6} // occurrences
      );
      // Here we evaluate the cumulative distribution function is the point 3.
      double cumDis1 = instanceOfRandomVariables.CumulativeDistFunc( 
         0, // index
         3.0 // evaluationPoint
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the cumulative distribution function at the point 3, is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * cumDis1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Evaluation of the Cumulative Distribution Function via parameters +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    cumulativeProbDistFunc( double[] values," );
      System.Console.WriteLine( "                            int[] occurrences," );
      System.Console.WriteLine( "                            double evaluationPoint )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the  cumulative  probability  distribution  at  the" );
      System.Console.WriteLine( "     point 3, of the probability distribution which  corresponds  to  the" );
      System.Console.WriteLine( "     random variable R, which takes the following values: R(1) = 2,  R(2)" );
      System.Console.WriteLine( "     = 4, R(3) = 3, R(4) = 5, R(5) = 3." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    values = {1.0, 2.0, 3.0, 4.0, 5.0}" );
      System.Console.WriteLine( "    occurrences = {2, 4, 3, 5, 3}" );
      System.Console.WriteLine( "    evaluationPoint = 3" );
      // Here we evaluate the  cumulative  distribution  function  at  a  given
      // point associative  with  the  random  variable  which  is  passed  via
      // parameters.
      double cumDisParam1 = instanceOfRandomVariables.CumulativeProbDistFunc( 
         new double[] {1.0, 2.0, 3.0, 4.0, 5.0}, // values
         new int[] {2, 4, 3, 5, 3}, // occurrences
         3.0 // evaluationPoint
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the cumulative distribution function at the point 3, is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * cumDisParam1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Mean of a Random Variable +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedValue( int index )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we set the Random Variable R,  which  takes  the  corresponding" );
      System.Console.WriteLine( "     values R(1) = 2, R(2) = 4,  R(3)  =  2,  R(4)  =  6;  to  the  first" );
      System.Console.WriteLine( "     position with the  internal  table  of  random  variables  and  then" );
      System.Console.WriteLine( "     evaluates and return the value of its expected value." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    index = 0" );
      // Here we set a random variable to the 1st position within the  internal
      // table.
      instanceOfRandomVariables.InsertRandomVariable( 
         0, // index
         new double[] {1.0, 2.0, 3.0, 4.0}, // values
         new int[] {2, 4, 2, 6} // occurrences
      );
      // Here we evaluate the expected value of the random variable  which  has
      // just been set.
      double mean1 = instanceOfRandomVariables.ExpectedValue( 
         0 // index
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the expected value of the  Random  Variable  in  the  1st" );
      System.Console.WriteLine( "    position within the internal table of Random Variables is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * mean1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Mean of a Random Variable via parameters +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedValue( double[] values," );
      System.Console.WriteLine( "                   int[] occurrences )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the expected value of the random variable R,  which" );
      System.Console.WriteLine( "     takes the following values R(1) = 2, R(2) = 4, R(3) = 2, R(4) = 6." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    values = {1.0, 2.0, 3.0, 4.0}" );
      System.Console.WriteLine( "    occurrences = {2, 4, 2, 6}" );
      // Here we evaluate the expected value of the random  variables  provided
      // via parameters.
      double mean2 = instanceOfRandomVariables.ExpectedValue( 
         new double[] {1.0, 2.0, 3.0, 4.0}, // values
         new int[] {2, 4, 2, 6} // occurrences
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The expected value of the random variable considered is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * mean2 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Expected Value of a Random Variable +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedValue( int index )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we set the Random Variable R,  which  takes  the  corresponding" );
      System.Console.WriteLine( "     values R(1) = 2, R(2) = 4,  R(3)  =  2,  R(4)  =  6;  to  the  first" );
      System.Console.WriteLine( "     position with the  internal  table  of  random  variables  and  then" );
      System.Console.WriteLine( "     evaluates and return the value of its expected value." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    index = 0" );
      // Here we set a random variable to the 1st position within the  internal
      // table.
      instanceOfRandomVariables.InsertRandomVariable( 
         0, // index
         new double[] {1.0, 2.0, 3.0, 4.0}, // values
         new int[] {2, 4, 2, 6} // occurrences
      );
      // Here we evaluate the expected value of the random variable  which  has
      // just been set.
      double expectedValue1 = instanceOfRandomVariables.ExpectedValue( 
         0 // index
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The expected value of the Random Variable in the 1st  position  within" );
      System.Console.WriteLine( "    the internal table of Random Variables is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * expectedValue1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Expected Value of a Random Variable via parameters +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    expectedValue( double[] values," );
      System.Console.WriteLine( "                   int[] occurrences )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the expectedValue of the random variable  R,  which" );
      System.Console.WriteLine( "     takes the following values R(1) = 2, R(2) = 4, R(3) = 2, R(4) = 6." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    values = {1.0, 2.0, 3.0, 4.0}" );
      System.Console.WriteLine( "    occurrences = {2, 4, 2, 6}" );
      // Here we evaluate the expectedValue of the  random  variables  provided
      // via parameters.
      double expectedValue2 = instanceOfRandomVariables.ExpectedValue( 
         new double[] {1.0, 2.0, 3.0, 4.0}, // values
         new int[] {2, 4, 2, 6} // occurrences
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The expected value of the random variable considered is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * expectedValue2 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Variance of a Random Variable +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    variance( int index )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we set the Random Variable R,  which  takes  the  corresponding" );
      System.Console.WriteLine( "     values R(1) = 2, R(2) = 4,  R(3)  =  2,  R(4)  =  6;  to  the  first" );
      System.Console.WriteLine( "     position with the  internal  table  of  random  variables  and  then" );
      System.Console.WriteLine( "     evaluates and return the value of its variance." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    index = 0" );
      // Here we set a random variable to the 1st position within the  internal
      // table.
      instanceOfRandomVariables.InsertRandomVariable( 
         0, // index
         new double[] {1.0, 2.0, 3.0, 4.0}, // values
         new int[] {2, 4, 2, 6} // occurrences
      );
      // Here we evaluate the variance of the random variable  which  has  just
      // been set.
      double variance1 = instanceOfRandomVariables.Variance( 
         0 // index
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The value of the variance of the Random Variable in the  1st  position" );
      System.Console.WriteLine( "    within the internal table of Random Variables is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * variance1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Variance of a Random Variable via parameters +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    variance( double[] values," );
      System.Console.WriteLine( "              int[] occurrences )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the variance of the random variable R, which  takes" );
      System.Console.WriteLine( "     the following values R(1) = 2, R(2) = 4, R(3) = 2, R(4) = 6." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    values = {1.0, 2.0, 3.0, 4.0}" );
      System.Console.WriteLine( "    occurrences = {2, 4, 2, 6}" );
      // Here we evaluate the variance of the  random  variables  provided  via
      // parameters.
      double variance2 = instanceOfRandomVariables.Variance( 
         new double[] {1.0, 2.0, 3.0, 4.0}, // values
         new int[] {2, 4, 2, 6} // occurrences
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The variance of the random variable considered is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * variance2 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( " " );
   }
}
