using System;
using WebCab.Lib.Util.Example;

public class NormalConfidenceClient {
   public static void Main( String[] args ) {
      // used components
      NormalConfidence instanceOfNormalConfidence = new NormalConfidence();
      //
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "                   ###########################################" );
      System.Console.WriteLine( "                   # NormalConfidence Console Client Example #" );
      System.Console.WriteLine( "                   ###########################################" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " Overview" );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Within this client we illustrate the use  of  each  of  the  methods" );
      System.Console.WriteLine( "    within the" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Confidence Interval of the Mean +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    meanConfidence( int size," );
      System.Console.WriteLine( "                    double mean," );
      System.Console.WriteLine( "                    double standardDeviation," );
      System.Console.WriteLine( "                    double confidence )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the 90 percent  confidence  interval  of  the  mean" );
      System.Console.WriteLine( "     where the sample has 20 elements, a  mean  of  10,  and  a  standard" );
      System.Console.WriteLine( "     deviation of 2." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    size = 20" );
      System.Console.WriteLine( "    mean = 10" );
      System.Console.WriteLine( "    standardDeviation = 2" );
      System.Console.WriteLine( "    confidence = 90" );
      // Here we evaluate the confidence interval of the mean.
      double[] confidenceIntervalMean1 = instanceOfNormalConfidence.MeanConfidence( 
         20, // size
         10.0, // mean
         2.0, // standardDeviation
         90.0 // confidence
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The 90 percent confidence interval is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( confidenceIntervalMean1, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Confidence Interval of the Difference between Means +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    meansDifference( int size1," );
      System.Console.WriteLine( "                     int size2," );
      System.Console.WriteLine( "                     double mean1," );
      System.Console.WriteLine( "                     double mean2," );
      System.Console.WriteLine( "                     double standardDeviation1," );
      System.Console.WriteLine( "                     double standardDeviation2," );
      System.Console.WriteLine( "                     double confidence )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here   we  evaluate  the  90  percent  confidence  interval  of  the" );
      System.Console.WriteLine( "     difference between the means of the following two samples:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - 1st Sample: Size = 20, Mean = 10, Standard Deviation = 2" );
      System.Console.WriteLine( "        - 2nd Sample: Size = 15, Mean = 12, Standard Deviation 2.3" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    size1 = 20" );
      System.Console.WriteLine( "    size2 = 15" );
      System.Console.WriteLine( "    mean1 = 10" );
      System.Console.WriteLine( "    mean2 = 12" );
      System.Console.WriteLine( "    standardDeviation1 = 2" );
      System.Console.WriteLine( "    standardDeviation2 = 2.3" );
      System.Console.WriteLine( "    confidence = 90" );
      // Here we evaluate the 90 percent confidence interval of the  difference
      // between means.
      double[] confDiffMeans1 = instanceOfNormalConfidence.MeansDifference( 
         20, // size1
         15, // size2
         10.0, // mean1
         12.0, // mean2
         2.0, // standardDeviation1
         2.3, // standardDeviation2
         90.0 // confidence
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The 90 percent confidence interval is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( confDiffMeans1, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Sample Size needed for a given Error Level +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    meanSize( double standardDeviation," );
      System.Console.WriteLine( "              double errorLevel," );
      System.Console.WriteLine( "              double confidence )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the sample size needed in order to obtain  a  given" );
      System.Console.WriteLine( "     specified standard error level to a confidence level of  90  percent" );
      System.Console.WriteLine( "     when the standard deviation of the sample is  2,  and  the  standard" );
      System.Console.WriteLine( "     error permissible is 1." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    standardDeviation = 2" );
      System.Console.WriteLine( "    errorLevel = 1" );
      System.Console.WriteLine( "    confidence = 90" );
      // Evaluate the sample size needed in order to obtain a  given  specified
      // standard error level.
      double sampleSize1 = instanceOfNormalConfidence.MeanSize( 
         2.0, // standardDeviation
         1.0, // errorLevel
         90.0 // confidence
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The sample size required is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * sampleSize1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Confidence interval of Proportions +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    percentageConfidence( int size," );
      System.Console.WriteLine( "                          double proportion," );
      System.Console.WriteLine( "                          double confidence )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the interval for which a proportion of  50  percent" );
      System.Console.WriteLine( "     of the sample lies within the  interval  with  a  confidence  of  90" );
      System.Console.WriteLine( "     percent." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    size = 20" );
      System.Console.WriteLine( "    proportion = 0.5" );
      System.Console.WriteLine( "    confidence = 90" );
      // Here     we  evaluate  the  90  percent  confidence  interval  of  the
      // proportions of a given set.
      double[] confPro1 = instanceOfNormalConfidence.PercentageConfidence( 
         20, // size
         0.5, // proportion
         90.0 // confidence
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The confidence interval is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( confPro1, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Sample Size need for Error +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    percentageSize( double proportion," );
      System.Console.WriteLine( "                    double errorLevel," );
      System.Console.WriteLine( "                    double confidence )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the sample size needed in order to ensure that  the" );
      System.Console.WriteLine( "     standard error is less that 1, when the  proportion  of  the  sample" );
      System.Console.WriteLine( "     which lies within the confidence interval  is  80  percent  and  the" );
      System.Console.WriteLine( "     confidence level of the confidence interval is 90 percent." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    proportion = 80" );
      System.Console.WriteLine( "    errorLevel = 1" );
      System.Console.WriteLine( "    confidence = 90" );
      // Here we evaluate the size of the sample which is necessary  to  ensure
      // that the standard error is less than 1.
      double sampleSizeError1 = instanceOfNormalConfidence.PercentageSize( 
         80.0, // proportion
         1.0, // errorLevel
         90.0 // confidence
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The sample size required is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * sampleSizeError1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ One-sided Confidence interval of the mean +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    sideMean( int size," );
      System.Console.WriteLine( "              double mean," );
      System.Console.WriteLine( "              double standardDeviation," );
      System.Console.WriteLine( "              double confidence )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the one-sided 95 percent confidence interval  of  a" );
      System.Console.WriteLine( "     sample with 40 elements, a mean of 20, and a standard  deviation  of" );
      System.Console.WriteLine( "     3." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    size = 40" );
      System.Console.WriteLine( "    mean = 20" );
      System.Console.WriteLine( "    standardDeviation = 3" );
      System.Console.WriteLine( "    confidence = 95" );
      // Here we evaluate the one-sided confidence interval of the mean.
      double[] oneSidedMean1 = instanceOfNormalConfidence.SideMean( 
         40, // size
         20.0, // mean
         3.0, // standardDeviation
         95.0 // confidence
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The one-sided confidence interval is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( oneSidedMean1, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ One-sided confidence interval about the proportion +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    sidePercentage( int size," );
      System.Console.WriteLine( "                    double proportion," );
      System.Console.WriteLine( "                    double confidence )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we construct the confidence interval of the proportion  with  a" );
      System.Console.WriteLine( "     confidence of 90 percent when the size of the sample  is  30,  which" );
      System.Console.WriteLine( "     represents a proportion of 40 percent of the entire population." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    size = 30" );
      System.Console.WriteLine( "    proportion = 40" );
      System.Console.WriteLine( "    confidence = 90" );
      // Here we evaluate the one-sided confidence interval of the proportion.
      double[] oneSidedProportion1 = instanceOfNormalConfidence.SidePercentage( 
         30, // size
         40.0, // proportion
         90.0 // confidence
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The one-sided 90 percent confidence interval of the proportion is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( oneSidedProportion1, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Confidence Interval of the difference between Proportions +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    percentageDifference( int size1," );
      System.Console.WriteLine( "                          int size2," );
      System.Console.WriteLine( "                          double proportion1," );
      System.Console.WriteLine( "                          double proportion2," );
      System.Console.WriteLine( "                          double confidence )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here   we  evaluate  the  90  percent  confidence  interval  of  the" );
      System.Console.WriteLine( "     difference between the proportions of two samples when:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - 1st Sample: Size = 20, Proportion of the  entire  population  =" );
      System.Console.WriteLine( "        30 percent" );
      System.Console.WriteLine( "        - 2nd Sample: Size = 40, Proportion of the entire populaton =  60" );
      System.Console.WriteLine( "        percent" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    size1 = 20" );
      System.Console.WriteLine( "    size2 = 40" );
      System.Console.WriteLine( "    proportion1 = 30" );
      System.Console.WriteLine( "    proportion2 = 60" );
      System.Console.WriteLine( "    confidence = 90" );
      // Here we evaluate the confidence interval  of  the  difference  between
      // the proportions of two samples.
      double[] confDiff1 = instanceOfNormalConfidence.PercentageDifference( 
         20, // size1
         40, // size2
         30.0, // proportion1
         60.0, // proportion2
         90.0 // confidence
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The 90 percent confidence  interval  of  the  difference  between  the" );
      System.Console.WriteLine( "    proportions is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( confDiff1, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( " " );
   }
}
