using System;
using WebCab.Lib.Util.Example;

public class GroupedDataClient {
   public static void Main( String[] args ) {
      // used components
      GroupedData instanceOfGroupedData = new GroupedData();
      //
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "                      ######################################" );
      System.Console.WriteLine( "                      # GroupedData Console Client Example #" );
      System.Console.WriteLine( "                      ######################################" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " Overview" );
      System.Console.WriteLine( " --------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    Within this client we provide an example for  each  of  the  methods" );
      System.Console.WriteLine( "    contained within the GroupedData class." );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "    Within this example we  will  consider  consider  the  grouped  data" );
      System.Console.WriteLine( "    which consists of  the  heights  of  a  collection  of  people.  The" );
      System.Console.WriteLine( "    grouped data for the collection of people we are considering  is  as" );
      System.Console.WriteLine( "    follows:" );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( "       - Height 0m - 1.00m, Number  of  people  within  this  group  (or" );
      System.Console.WriteLine( "       class) is equal to 5" );
      System.Console.WriteLine( "       - Height 1.01m - 1.50m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "       class) is equal to 25" );
      System.Console.WriteLine( "       - Height 1.51m - 2.00m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "       class) is equal to 30" );
      System.Console.WriteLine( "       - Height 2.01m - 3.00m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "       class) is equal to 3" );
      System.Console.WriteLine( "       " );
      System.Console.WriteLine( "    " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Registering the Midpoints +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    setMidpoints( double[] midPoints )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here  we  registered  the  mid-points  of  the  grouped  data  which" );
      System.Console.WriteLine( "     consists of the heights of a collection of people. The grouped  data" );
      System.Console.WriteLine( "     for the collection of people we are considering is as follows:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - Height 0m - 1.20m, Number  of  people  within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 5" );
      System.Console.WriteLine( "        - Height 1.01m - 1.50m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 25" );
      System.Console.WriteLine( "        - Height 1.51m - 2.00m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 30" );
      System.Console.WriteLine( "        - Height 2.01m - 3.00m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 3" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    midPoints = {0.6, 1.25, 1.75, 2.5}" );
      // Here we register the midpoints of the grouped data set.
      instanceOfGroupedData.SetMidpoints( 
         new double[] {0.6, 1.25, 1.75, 2.5} // midPoints
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The midpoints has the grouped data have now been registered." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Get the Registered Midpoints +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    getMidpoint(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we register the midpoints of a grouped data set.
      instanceOfGroupedData.SetMidpoints( 
         new double[] {0.6, 1.25, 1.75, 2.5} // midPoints
      );
      // Here we get the midpoints which have been registered.
      double[] getRegMidpoints1 = instanceOfGroupedData.GetMidpoint( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The midpoints of the grouped data set which have just been set are:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( getRegMidpoints1, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Registering the Frequencies +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    setFrequencies( int[] frequencies )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we first set the midpoints of a data set, namely" );
      System.Console.WriteLine( "     Here we register (i.e. set) the  frequencies  of  the  grouped  data" );
      System.Console.WriteLine( "     which consists of  the  heights  of  a  collection  of  people.  The" );
      System.Console.WriteLine( "     grouped data for the collection of people we are considering  is  as" );
      System.Console.WriteLine( "     follows:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - Height 0m - 1.20m, Number  of  people  within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 5" );
      System.Console.WriteLine( "        - Height 1.01m - 1.50m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 25" );
      System.Console.WriteLine( "        - Height 1.51m - 2.00m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 30" );
      System.Console.WriteLine( "        - Height 2.01m - 3.00m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 3" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    frequencies = {5, 25, 30, 3}" );
      // Here we register the frequencies of the elements  within  the  classes
      // of the grouped data set.
      instanceOfGroupedData.SetFrequencies( 
         new int[] {5, 25, 30, 3} // frequencies
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The frequencies of the grouped data has now been set." );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Get the Registered Frequencies +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    getFrequencies(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // Here we register the frequencies of the elements  within  the  classes
      // of the grouped data set.
      instanceOfGroupedData.SetFrequencies( 
         new int[] {5, 25, 30, 3} // frequencies
      );
      // Here we get the frequencies of the classes of the grouped data set.
      int[] getRegFrequencies1 = instanceOfGroupedData.GetFrequencies( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The frequencies of the grouped data which has just been set is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + MethodInvoker.arrayToString( getRegFrequencies1, ", " ) );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Sample Mean of a Grouped Data Set +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    sampleMean(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we first set the frequencies of the data set, namely" );
      System.Console.WriteLine( "     Here we evaluate the sample mean of the grouped data which  consists" );
      System.Console.WriteLine( "     of the heights of a collection of people. The grouped data  for  the" );
      System.Console.WriteLine( "     collection of people we are considering is as follows:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - Height 0m - 1.20m, Number  of  people  within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 5" );
      System.Console.WriteLine( "        - Height 1.01m - 1.50m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 25" );
      System.Console.WriteLine( "        - Height 1.51m - 2.00m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 30" );
      System.Console.WriteLine( "        - Height 2.01m - 3.00m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 3" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // We first register the midpoints of a grouped data set.
      instanceOfGroupedData.SetMidpoints( 
         new double[] {0.6, 1.25, 1.75, 2.5} // midPoints
      );
      // We then register the frequencies of the elements  within  the  classes
      // of the grouped data set.
      instanceOfGroupedData.SetFrequencies( 
         new int[] {5, 25, 30, 3} // frequencies
      );
      // Finally once  the  grouped  data  has  been  registered  we  call  the
      // business method which evaluates the sample mean.
      double mean1 = instanceOfGroupedData.SampleMean( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The sample mean of the grouped data set is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * mean1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Sample Variance of a Grouped Data Set +" );
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    sampleVariance(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the sample mean of the grouped data which  consists" );
      System.Console.WriteLine( "     of the heights of a collection of people. The grouped data  for  the" );
      System.Console.WriteLine( "     collection of people we are considering is as follows:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - Height 0m - 1.20m, Number  of  people  within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 5" );
      System.Console.WriteLine( "        - Height 1.01m - 1.50m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 25" );
      System.Console.WriteLine( "        - Height 1.51m - 2.00m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 30" );
      System.Console.WriteLine( "        - Height 2.01m - 3.00m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 3" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // We first register the midpoints of a grouped data set.
      instanceOfGroupedData.SetMidpoints( 
         new double[] {0.6, 1.25, 1.75, 2.5} // midPoints
      );
      // We then register the frequencies of the elements  within  the  classes
      // of the grouped data set.
      instanceOfGroupedData.SetFrequencies( 
         new int[] {5, 25, 30, 3} // frequencies
      );
      // Finally once  the  grouped  data  has  been  registered  we  call  the
      // business method which evaluates the sample variance.
      double variance1 = instanceOfGroupedData.SampleVariance( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The sample variance of the grouped data set is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * variance1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( "+ Standard Deviation of a Grouped Data Set +" );
      System.Console.WriteLine( "++++++++++++++++++++++++++++++++++++++++++++" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " Within this example we test the following method:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    standardDeviation(  )" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " Question:" );
      System.Console.WriteLine( " ---------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "     Here we evaluate the sample mean of the grouped data which  consists" );
      System.Console.WriteLine( "     of the heights of a collection of people. The grouped data  for  the" );
      System.Console.WriteLine( "     collection of people we are considering is as follows:" );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( "        - Height 0m - 1.20m, Number  of  people  within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 5" );
      System.Console.WriteLine( "        - Height 1.01m - 1.50m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 25" );
      System.Console.WriteLine( "        - Height 1.51m - 2.00m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 30" );
      System.Console.WriteLine( "        - Height 2.01m - 3.00m, Number of people within  this  group  (or" );
      System.Console.WriteLine( "        class) is equal to 3" );
      System.Console.WriteLine( "        " );
      System.Console.WriteLine( "     " );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " Parameter values required to solve this problem:" );
      System.Console.WriteLine( " ------------------------------------------------" );
      System.Console.WriteLine( " " );
      // We first register the midpoints of a grouped data set.
      instanceOfGroupedData.SetMidpoints( 
         new double[] {0.6, 1.25, 1.75, 2.5} // midPoints
      );
      // We then register the frequencies of the elements  within  the  classes
      // of the grouped data set.
      instanceOfGroupedData.SetFrequencies( 
         new int[] {5, 25, 30, 3} // frequencies
      );
      // Finally once  the  grouped  data  has  been  registered  we  call  the
      // business method which evaluates the standard deviation.
      double standardDeviation1 = instanceOfGroupedData.StandardDeviation( 
      );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " Answer evaluated:" );
      System.Console.WriteLine( " -----------------" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "    The standard deviation of the grouped data set is:" );
      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       " + ( int )( 10000 * standardDeviation1 ) / 10000.0 );
      System.Console.WriteLine( " " );

      System.Console.WriteLine( " " );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" );
      System.Console.WriteLine( "       -------------------------------------------------------------------" );
      System.Console.WriteLine( " " );
   }
}
