Imports System
Imports WebCab.Lib.Util.Example
Imports WebCab.Libraries.Statistics.Hypothesis

Module NormalHypothesisClient
   Sub Main()
      ' used components
      Dim instanceOfNormalHypothesis As WebCab.Libraries.Statistics.Hypothesis.NormalHypothesis = New WebCab.Libraries.Statistics.Hypothesis.NormalHypothesis
      '
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "                   ###########################################" )
      System.Console.WriteLine( "                   # NormalHypothesis Console Client Example #" )
      System.Console.WriteLine( "                   ###########################################" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " Overview" )
      System.Console.WriteLine( " --------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    Within       this  client  we  illustrate  the  application  of  the" )
      System.Console.WriteLine( "    NormalHypothesis class." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Press ENTER or SPACE to scroll down." )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Hypothesis testing for the difference between means +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    meansDifference( double mean1," )
      System.Console.WriteLine( "                     double mean2," )
      System.Console.WriteLine( "                     double claimedDifference," )
      System.Console.WriteLine( "                     double standardDeviation1," )
      System.Console.WriteLine( "                     double standardDeviation2," )
      System.Console.WriteLine( "                     int size1," )
      System.Console.WriteLine( "                     int size2," )
      System.Console.WriteLine( "                     double significanceLevel )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we preformed the hypothesis test where the null  hypothesis  is" )
      System.Console.WriteLine( "     that the difference between the means  is  5,  and  the  alternative" )
      System.Console.WriteLine( "     hypothesis is that they are not 5, to a level of  confidence  of  99" )
      System.Console.WriteLine( "     percent." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    mean1 = 165" )
      System.Console.WriteLine( "    mean2 = 160" )
      System.Console.WriteLine( "    claimedDifference = 5" )
      System.Console.WriteLine( "    standardDeviation1 = 3" )
      System.Console.WriteLine( "    standardDeviation2 = 4" )
      System.Console.WriteLine( "    size1 = 15" )
      System.Console.WriteLine( "    size2 = 13" )
      System.Console.WriteLine( "    significanceLevel = 99" )
      ' Performs hypothesis testing for the difference between means.
      Dim diffMeans1 As Boolean = instanceOfNormalHypothesis.MeansDifference( _
         165.0, _
         160.0, _
         5.0, _
         3.0, _
         4.0, _
         15, _
         13, _
         99.0 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The statement that the null hypothesis is be rejected is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( diffMeans1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( "+ Hypothesis Testing about the mean +" )
      System.Console.WriteLine( "+++++++++++++++++++++++++++++++++++++" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " Within this example we test the following method:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    meanTest( double claimedMean," )
      System.Console.WriteLine( "              double mean," )
      System.Console.WriteLine( "              double standardDeviation," )
      System.Console.WriteLine( "              int sampleSize," )
      System.Console.WriteLine( "              double significanceLevel )" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " Question:" )
      System.Console.WriteLine( " ---------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "     Here we test the hypothesis to  a  95  percentage  confidence  level" )
      System.Console.WriteLine( "     where the null hypothesis is that the  mean  of  the  population  is" )
      System.Console.WriteLine( "     165; when a sample of the population of 15, a standard deviation  of" )
      System.Console.WriteLine( "     5, and a mean of 168." )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " Parameter values required to solve this problem:" )
      System.Console.WriteLine( " ------------------------------------------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    claimedMean = 165" )
      System.Console.WriteLine( "    mean = 168" )
      System.Console.WriteLine( "    standardDeviation = 5" )
      System.Console.WriteLine( "    sampleSize = 15" )
      System.Console.WriteLine( "    significanceLevel = 95" )
      ' Here we test the hypothesis that the mean.
      Dim hypoMean1 As Boolean = instanceOfNormalHypothesis.MeanTest( _
         165.0, _
         168.0, _
         5.0, _
         15, _
         95.0 _
      )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " Answer evaluated:" )
      System.Console.WriteLine( " -----------------" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "    The statement that the null hypothesis is be rejected is:" )
      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       "  )
      System.Console.WriteLine( hypoMean1 )
      System.Console.WriteLine( " " )

      System.Console.WriteLine( " " )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( "       - Please scroll up to the top of the console to view the examples -" )
      System.Console.WriteLine( "       -------------------------------------------------------------------" )
      System.Console.WriteLine( " " )
   End Sub
End Module

